/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package controlador;

import java.util.Observable;
import javax.swing.tree.MutableTreeNode;
import modelo.*;
import vista.*;

/**
 * Clase Controlador, esta clase es la que controla todas las variables
 */
public class Controlador extends Observable {

    /**
     * Metodo que permite ejecutar el programa
     * @param args variable que se le pasa por defecto al main
     */
    public static void main(String args[]) {
        String resultado = "";
        int ps=0;
        Actor actor = new Actor();
        CasodeUso CU = new CasodeUso();
        DatoEspecifico DE = new DatoEspecifico();
        DocumentoReq DReq = new DocumentoReq();
        //ExcepcionCU ECU = new ExcepcionCU();
        Objetivo Ob = new Objetivo();
        Organizacion Org = new Organizacion();
        Participante Pa = new Participante();
        Parrafo Parr = new Parrafo();
        PasoCU PCU = new PasoCU();
        RequisitoFuncional RF = new RequisitoFuncional();
        RequisitoInformacion RI = new RequisitoInformacion();
        RequisitoNoFuncional RNF = new RequisitoNoFuncional();
        RequisitoRestriccion RRes = new RequisitoRestriccion();
        Reunion Reu = new Reunion();
        Subobjetivo SO = new Subobjetivo();
        MutableTreeNode insertNode = null;
        int insertIndex = 0;
        GestorDocus GD = new GestorDocus();
        jfrmPrincipal jfrmPrin = new jfrmPrincipal(resultado);
        jfrmPrin.setExtendedState(jfrmPrincipal.MAXIMIZED_BOTH);
        jfrmActor jfrmAc = new jfrmActor(jfrmPrin, DReq, insertNode, insertIndex);
        jfrmCasodeUso jfrmCU = new jfrmCasodeUso(jfrmPrin, DReq, insertNode, insertIndex);
        jfrmDatoEspecifico jfrmDE = new jfrmDatoEspecifico(jfrmPrin, DReq, insertNode, insertIndex, RI);
        //jfrmExcepcionCU jfrmECU = new jfrmExcepcionCU(jfrmPrin, DReq, insertNode, insertIndex, CU, PCU, ps);
        jfrmObjetivo jfrmOb = new jfrmObjetivo(jfrmPrin, DReq, insertNode, insertIndex);
        jfrmOrganizacion jfrmOr =new jfrmOrganizacion(jfrmPrin, DReq, insertNode, insertIndex);
        jfrmParticipante jfrmPa = new jfrmParticipante(jfrmPrin, DReq, insertNode, insertIndex);
        jfrmParrafo jfrmParr = new jfrmParrafo(jfrmPrin, DReq, insertNode, insertIndex);
        jfrmPaso jfrmPaCU = new jfrmPaso(jfrmPrin, DReq, insertNode, insertIndex, CU);
        jfrmReqFuncional jfrmRF = new jfrmReqFuncional(jfrmPrin, DReq, insertNode, insertIndex);
        jfrmReqInformacion jfrmRI = new jfrmReqInformacion(jfrmPrin, DReq, insertNode, insertIndex);
        jfrmReqNoFuncional jfrmRNF = new jfrmReqNoFuncional(jfrmPrin, DReq, insertNode, insertIndex);
        jfrmReqRestriccion jfrmRRes = new jfrmReqRestriccion(jfrmPrin, DReq, insertNode, insertIndex);
        jfrmReunion jfrmRe = new jfrmReunion(jfrmPrin, DReq, insertNode, insertIndex);
        jfrmSubobjetivo jfrmSO = new jfrmSubobjetivo(jfrmPrin, DReq, insertNode, insertIndex, Ob);
        jfrmDocumentoReq jfrmDR = new jfrmDocumentoReq(jfrmPrin, GD, DReq);

        jfrmPrin.setVisible(true);

        GD.addObserver(jfrmDR);
        DReq.addObserver(jfrmPrin);
        SO.addObserver(jfrmSO);
        Reu.addObserver(jfrmRe);
        RRes.addObserver(jfrmRRes);
        RNF.addObserver(jfrmRNF);
        RI.addObserver(jfrmRI);
        RF.addObserver(jfrmRF);
        PCU.addObserver(jfrmPaCU);
        Parr.addObserver(jfrmParr);
        Pa.addObserver(jfrmPa);
        Org.addObserver(jfrmOr);
        Ob.addObserver(jfrmOb);
        //ECU.addObserver(jfrmECU);
        DE.addObserver(jfrmDE);
        CU.addObserver(jfrmCU);
        actor.addObserver(jfrmAc);

    }
}
