/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * jfrmAnadirF.java
 *
 * Created on 15-ene-2012, 23:39:53
 */

package vista;

import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JOptionPane;
import modelo.DocumentoReq;

/**
 * Clase que añade una traza origen en los objetos rastreables
 */
public class jfrmAnadirTO extends javax.swing.JFrame {
    JFrame jfAux;
    DocumentoReq auxDocPpal;
    DefaultListModel listModel = new DefaultListModel();
    DefaultListModel listModel2 = new DefaultListModel();
    JList auxJLC;

    /**
     * Constructor para un requisito de restricción
     * @param jf es el formulario principal
     * @param docPpal es el documento donde se guardan todas las variables
     * @param jl
     * @param ident
     */
    public jfrmAnadirTO(jfrmReqRestriccion jf, DocumentoReq docPpal, JList jl, String ident) {
        initComponents();
        jfAux=jf;
        auxDocPpal=docPpal;
        auxJLC=jl;
        inicializarJL(jlstFila, ident);
    }

    /**
     * Constructor para un requisito funcional
     * @param jf es el formulario principal
     * @param docPpal es el documento donde se guardan todas las variables
     * @param jl
     * @param ident
     */
    public jfrmAnadirTO(jfrmReqFuncional jf, DocumentoReq docPpal, JList jl, String ident) {
        initComponents();
        jfAux=jf;
        auxDocPpal=docPpal;
        auxJLC=jl;
        inicializarJL(jlstFila, ident);
    }

    /**
     * Constructor para un requisito no funcional
     * @param jf es el formulario principal
     * @param docPpal es el documento donde se guardan todas las variables
     * @param jl
     * @param ident
     */
    public jfrmAnadirTO(jfrmReqNoFuncional jf, DocumentoReq docPpal, JList jl, String ident) {
        initComponents();
        jfAux=jf;
        auxDocPpal=docPpal;
        auxJLC=jl;
        inicializarJL(jlstFila, ident);
    }

    /**
     * Constructor para un requisito de información
     * @param jf es el formulario principal
     * @param docPpal es el documento donde se guardan todas las variables
     * @param jl
     * @param ident
     */
    public jfrmAnadirTO(jfrmReqInformacion jf, DocumentoReq docPpal, JList jl, String ident) {
        initComponents();
        jfAux=jf;
        auxDocPpal=docPpal;
        auxJLC=jl;
        inicializarJL(jlstFila, ident);
    }

    /**
     * Constructor para un objetivo
     * @param jf es el formulario principal
     * @param docPpal es el documento donde se guardan todas las variables
     * @param jl
     * @param ident
     */
    public jfrmAnadirTO(jfrmObjetivo jf, DocumentoReq docPpal, JList jl, String ident) {
        initComponents();
        jfAux=jf;
        auxDocPpal=docPpal;
        auxJLC=jl;
        inicializarJL(jlstFila, ident);
    }

    /**
     * Inicializador de las listas de los distintos tipos de objetos
     * @param auxJLF2
     * @param ident
     */
    private void inicializarJL(JList auxJLF2, String ident) {
        for (int i = 0; i < auxDocPpal.getObjetivo().size(); i++) {
            if (!auxDocPpal.getObjetivo().get(i).getIdent().equals(ident)&&(!ident.startsWith("OB"))) {
                listModel.addElement(auxDocPpal.getObjetivo().get(i).getIdent());
            }
        }
        for (int i = 0; i < auxDocPpal.getRequisitoInformacion().size(); i++) {
            if (!auxDocPpal.getRequisitoInformacion().get(i).getIdent().equals(ident)&&(!ident.startsWith("RI"))) {
                listModel.addElement(auxDocPpal.getRequisitoInformacion().get(i).getIdent());
            }
        }
        for (int i = 0; i < auxDocPpal.getRequisitoRestriccion().size(); i++) {
            if (!auxDocPpal.getRequisitoRestriccion().get(i).getIdent().equals(ident)&&(!ident.startsWith("RRE"))) {
                listModel.addElement(auxDocPpal.getRequisitoRestriccion().get(i).getIdent());
            }
        }
        for (int i = 0; i < auxDocPpal.getRequisitoFuncional().size(); i++) {
            if (!auxDocPpal.getRequisitoFuncional().get(i).getIdent().equals(ident)&&(!ident.startsWith("RF"))) {
                listModel.addElement(auxDocPpal.getRequisitoFuncional().get(i).getIdent());
            }
        }
        for (int i = 0; i < auxDocPpal.getRequisitoNoFuncional().size(); i++) {
            if (!auxDocPpal.getRequisitoNoFuncional().get(i).getIdent().equals(ident)&&(!ident.startsWith("RNF"))) {
                listModel.addElement(auxDocPpal.getRequisitoNoFuncional().get(i).getIdent());
            }
        }
        jlstFila.setModel(listModel);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jlstFila = new javax.swing.JList();
        jbtnAceptar = new javax.swing.JButton();
        jbtnCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Traza Origen");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jScrollPane1.setViewportView(jlstFila);

        jbtnAceptar.setText("Aceptar");
        jbtnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAceptarActionPerformed(evt);
            }
        });

        jbtnCancelar.setText("Cancelar");
        jbtnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE)
                .addGap(36, 36, 36)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jbtnAceptar, javax.swing.GroupLayout.DEFAULT_SIZE, 75, Short.MAX_VALUE)
                    .addComponent(jbtnCancelar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jbtnAceptar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jbtnCancelar, javax.swing.GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)
                        .addGap(139, 139, 139))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 191, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * formWindowClosed es el metodo que se activa cuando pulsamos la x de cerrar
     * @param evt
     */
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        jfAux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_formWindowClosed

    /**
     * jbtnCancelarActionPerformed Activa el boton cancelar
     * @param evt
     */
    private void jbtnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnCancelarActionPerformed
        jfAux.setEnabled(true);
        this.dispose();
}//GEN-LAST:event_jbtnCancelarActionPerformed

    /**
     * jbtnAceptarActionPerformed Activa el boton aceptar
     * @param evt
     */
    private void jbtnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAceptarActionPerformed
        if (jlstFila.getSelectedIndex() == (-1)) {
            auxJLC.setListData(jlstFila.getSelectedValues());
            mostrarmensaje("No ha insertado ninguna traza origen");
        } else {
            auxJLC.setListData(jlstFila.getSelectedValues());
            mostrarmensaje("Insertada la traza origen");
        }
        jfAux.setVisible(true);
        this.dispose();
    }//GEN-LAST:event_jbtnAceptarActionPerformed

    /**
    * @param args the command line arguments
    */
    /*public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
    public void run() {
    new jfrmAnadirF().setVisible(true);
    }
    });
    }*/

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton jbtnAceptar;
    private javax.swing.JButton jbtnCancelar;
    private javax.swing.JList jlstFila;
    // End of variables declaration//GEN-END:variables

    /**
     * Muestra un mensaje en un JOptionPane
     * @param mensaje a mostrar en el JOptionPane
     */
    private void mostrarmensaje(String mensaje) {
        JOptionPane.showMessageDialog(this, mensaje, "Advertencia",
                JOptionPane.WARNING_MESSAGE);
    }
}
