/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ExcepcionCU.java
 *
 * Created on 23-nov-2011, 17:02:59
 */

package vista;

import java.util.Observable;
import java.util.Observer;
import modelo.PasoCU;
import modelo.ExcepcionCU;
import javax.swing.JOptionPane;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import modelo.CasodeUso;
import modelo.DocumentoReq;

/**
 * jfrmExcepcionCU es el formulario con el cual podremos insertar todas las variables de la excepcion de un paso
 */
public class jfrmExcepcionCU extends javax.swing.JFrame implements Observer {

    DocumentoReq auxDocPpal;
    CasodeUso auxCU;
    PasoCU auxPasoCU;
    int auxps;
    ExcepcionCU newExCU;
    ExcepcionCU auxECU;
    jfrmPrincipal jfaux;
    MutableTreeNode auxinsertNode;
    int auxinsertIndex;
    boolean editar= false;
    MutableTreeNode parent;
    int insertIndex2;

    /**
     * Constructor de JFrame ExcepcionCU
     * @param jf es el formulario principal
     * @param docPpal es el documento donde se guardan todas las variables
     * @param insertNode el nodo a insertar
     * @param insertIndex el indice del nodo a insertar
     * @param CU el caso de uso
     * @param PS el paso
     */
    public jfrmExcepcionCU(jfrmPrincipal jf, DocumentoReq docPpal, MutableTreeNode insertNode, int insertIndex, CasodeUso CU, PasoCU PS, int ps) {
        auxinsertNode=insertNode;
        auxinsertIndex=insertIndex;
        jfaux=jf;
        auxps=ps;
        auxDocPpal=docPpal;
        auxPasoCU=PS;
        initComponents();
        jgrpbtnTipoAccion.add(jrbtnAccionSistema);
        jgrpbtnTipoAccion.add(jrbtnAccionActor);
        jgrpbtnTipoAccion.add(jrbtnInclusionExtension);
        jrbtnAccionSistema.setSelected(true);
        jrbtnAccionActor.setEnabled(false);
        jrbtnInclusionExtension.setEnabled(false);
        int l = 0, i=0;
        System.out.print("Este es el paso escogido "+ auxps);
        if (auxPasoCU.getExcepcionCU().size() != 0) {
            l = auxPasoCU.getExcepcionCU().size();
            l--;
            i = auxPasoCU.getExcepcionCU().get(l).getId_n();
        } else {
            i = 0;
        }
        String ident;
        ident ="EXCU"+String.valueOf(i+1)+". "+auxPasoCU.getIdent();
        jtxtId.setText(ident);
    }

    /**
     * editarPropiedades Método que edita las propiedades de una excepcion
     * @param ECU es la excepcion para editar
     */
    void editarPropiedades(ExcepcionCU ECU) {
        editar = true;
        auxECU = ECU;
        jtxtId.setText(ECU.getIdent());
        jtxaCondicion.setText(ECU.getCondicion());
        jtxtTerminacion.setText(ECU.getTerminacion());
        jrbtnAccionSistema.setSelected(ECU.getAccionSistema());
        jrbtnAccionActor.setSelected(ECU.getAccionActor());
        jrbtnInclusionExtension.setSelected(ECU.getInclusionExtension());
        jtxtActor.setText(ECU.getActor());
        jtxtInclusion.setText(ECU.getIE());
        jtxaAccion.setText(ECU.getAccion());
        jtxtValor.setText(String.valueOf(ECU.getValor()));
        jtxtUnidad.setText(ECU.getUnidad());
        jtxaComentarios.setText(ECU.getComentario());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jgrpbtnTipoAccion = new javax.swing.ButtonGroup();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtxaCondicion = new javax.swing.JTextArea();
        jLabel2 = new javax.swing.JLabel();
        jtxtTerminacion = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        jtxtId = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jtxaAccion = new javax.swing.JTextArea();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jtxtValor = new javax.swing.JTextField();
        jPanel4 = new javax.swing.JPanel();
        jtxtUnidad = new javax.swing.JTextField();
        jrbtnInclusionExtension = new javax.swing.JRadioButton();
        jtxtInclusion = new javax.swing.JTextField();
        jtxtActor = new javax.swing.JTextField();
        jrbtnAccionActor = new javax.swing.JRadioButton();
        jrbtnAccionSistema = new javax.swing.JRadioButton();
        jPanel3 = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jtxaComentarios = new javax.swing.JTextArea();
        jbtnAceptar = new javax.swing.JButton();
        jbtnCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Nueva Excepcion");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jLabel1.setText("Condición de terminación");

        jtxaCondicion.setColumns(20);
        jtxaCondicion.setRows(5);
        jScrollPane1.setViewportView(jtxaCondicion);

        jLabel2.setText("Terminación de la excepción");

        jtxtTerminacion.setText("PD");

        jLabel12.setText("Identificador:");

        jtxtId.setEditable(false);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, 65, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jtxtId, javax.swing.GroupLayout.PREFERRED_SIZE, 151, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(196, 196, 196))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(303, 303, 303))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 369, Short.MAX_VALUE)
                        .addGap(53, 53, 53))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(288, 288, 288))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jtxtTerminacion, javax.swing.GroupLayout.DEFAULT_SIZE, 369, Short.MAX_VALUE)
                        .addGap(53, 53, 53))))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGap(28, 28, 28)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtxtId)
                    .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 147, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jtxtTerminacion)
                .addGap(43, 43, 43))
        );

        jTabbedPane1.addTab("Condición/Terminación", jPanel1);

        jLabel3.setText("Tipo de acción");

        jLabel4.setText("Acción(es) realizada(s) por el sistema/ un actor");

        jtxaAccion.setColumns(20);
        jtxaAccion.setRows(5);
        jScrollPane2.setViewportView(jtxaAccion);

        jLabel5.setText("Rendimiento");

        jLabel6.setText("Valor:");

        jLabel7.setText("Unidad:");

        jtxtValor.setText("0");

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 354, Short.MAX_VALUE)
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 127, Short.MAX_VALUE)
        );

        jtxtUnidad.setText("dia");

        jrbtnInclusionExtension.setText("Inclusión/Extensión");

        jtxtInclusion.setText("el caso de uso");

        jtxtActor.setText("el usuario");

        jrbtnAccionActor.setText("Acción de un actor");

        jrbtnAccionSistema.setSelected(true);
        jrbtnAccionSistema.setText("Acción del sistema");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(21, 21, 21)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jtxtValor, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(49, 49, 49)
                        .addComponent(jLabel7)
                        .addGap(18, 18, 18)
                        .addComponent(jtxtUnidad, javax.swing.GroupLayout.PREFERRED_SIZE, 82, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jLabel5)
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel2Layout.createSequentialGroup()
                            .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(jPanel2Layout.createSequentialGroup()
                                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(jrbtnAccionActor)
                                        .addComponent(jrbtnInclusionExtension))
                                    .addGap(14, 14, 14)
                                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(jtxtActor, javax.swing.GroupLayout.DEFAULT_SIZE, 205, Short.MAX_VALUE)
                                        .addComponent(jtxtInclusion, javax.swing.GroupLayout.DEFAULT_SIZE, 205, Short.MAX_VALUE)))
                                .addComponent(jrbtnAccionSistema)
                                .addComponent(jLabel4)
                                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 365, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addComponent(jLabel3, javax.swing.GroupLayout.Alignment.LEADING)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel3)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(29, 29, 29)
                        .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(37, 37, 37))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jrbtnAccionSistema)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jrbtnAccionActor)
                            .addComponent(jtxtActor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jrbtnInclusionExtension)
                            .addComponent(jtxtInclusion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 74, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jtxtValor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7)
                    .addComponent(jtxtUnidad, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(76, 76, 76))
        );

        jTabbedPane1.addTab("Acción", jPanel2);

        jLabel8.setText("Comentarios");

        jtxaComentarios.setColumns(20);
        jtxaComentarios.setRows(5);
        jScrollPane3.setViewportView(jtxaComentarios);

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 402, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8))
                .addContainerGap(20, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(27, 27, 27)
                .addComponent(jLabel8)
                .addGap(18, 18, 18)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 191, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(70, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Comentarios", jPanel3);

        jbtnAceptar.setText("Aceptar");
        jbtnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAceptarActionPerformed(evt);
            }
        });

        jbtnCancelar.setText("Cancelar");
        jbtnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 437, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jbtnAceptar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jbtnCancelar))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 348, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(21, 21, 21)
                        .addComponent(jbtnAceptar)
                        .addGap(18, 18, 18)
                        .addComponent(jbtnCancelar)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * jbtnAceptarActionPerformed Activa el boton aceptar
     * @param evt
     */
    private void jbtnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAceptarActionPerformed
        String ident;
        int i, j=0, l=0;
        ident=jtxtId.getText();
        if (!editar) {
            if (auxPasoCU.getExcepcionCU().size() != 0) {
                l = auxPasoCU.getExcepcionCU().size();
                l--;
                i = auxPasoCU.getExcepcionCU().get(l).getId_n();
            } else {
                i = 0;
            }
            newExCU = auxPasoCU.nuevaExcepcion(i+1, auxPasoCU.getIdent(), jtxaCondicion.getText(), jtxtTerminacion.getText(), jrbtnAccionSistema.isSelected(), jrbtnAccionActor.isSelected(), jrbtnInclusionExtension.isSelected(), jtxtActor.getText(), jtxtInclusion.getText(), jtxaAccion.getText(), Integer.parseInt(jtxtValor.getText()), jtxtUnidad.getText(), jtxaComentarios.getText());
            MutableTreeNode node = new DefaultMutableTreeNode(newExCU.getIdent());
            DefaultTreeModel model = (DefaultTreeModel) jfaux.getJtreDocumento().getModel();
            model.insertNodeInto(node, auxinsertNode, auxinsertIndex);
        } else {
            boolean encontrado = false;
            i = 0;
            while (i < auxPasoCU.getExcepcionCU().size() && encontrado == false) {
                if (auxPasoCU.getExcepcionCU().get(i).getIdent().equals(ident)) {
                    encontrado = true;
                    auxPasoCU.getExcepcionCU().get(i).setCondicion(jtxaCondicion.getText());
                    auxPasoCU.getExcepcionCU().get(i).setTerminacion(jtxtTerminacion.getText());
                    auxPasoCU.getExcepcionCU().get(i).setAccionSistema(jrbtnAccionSistema.isSelected());
                    auxPasoCU.getExcepcionCU().get(i).setAccionActor(jrbtnAccionActor.isSelected());
                    auxPasoCU.getExcepcionCU().get(i).setInclusionExtension(jrbtnInclusionExtension.isSelected());
                    auxPasoCU.getExcepcionCU().get(i).setActor(jtxtActor.getText());
                    auxPasoCU.getExcepcionCU().get(i).setIE(jtxtInclusion.getText());
                    auxPasoCU.getExcepcionCU().get(i).setAccion(jtxaAccion.getText());
                    auxPasoCU.getExcepcionCU().get(i).setValor(Integer.parseInt(jtxtValor.getText()));
                    auxPasoCU.getExcepcionCU().get(i).setUnidad(jtxtUnidad.getText());
                    auxPasoCU.getExcepcionCU().get(i).setComentario(jtxaComentarios.getText());
                    auxPasoCU.getExcepcionCU().get(i).actualizarEBD(auxPasoCU.getExcepcionCU().get(i));
                }
                i++;
            }
        }
        jfaux.LeeArbol();
        mostrarmensaje("Insertado nueva Excepción");
        jfaux.setEnabled(true);
        this.dispose();
}//GEN-LAST:event_jbtnAceptarActionPerformed

    /**
     * jbtnCancelarActionPerformed Activa el boton cancelar
     * @param evt
     */
    private void jbtnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnCancelarActionPerformed
        jfaux.LeeArbol();
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_jbtnCancelarActionPerformed

    /**
     * formWindowClosed es el metodo que se activa cuando pulsamos la x de cerrar
     * @param evt
     */
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_formWindowClosed
    /**
    * @param args the command line arguments
    */
    
    /*public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
    public void run() {
    new jfrmExcepcionCU().setVisible(true);
    }
    });
    }*/

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JButton jbtnAceptar;
    private javax.swing.JButton jbtnCancelar;
    private javax.swing.ButtonGroup jgrpbtnTipoAccion;
    private javax.swing.JRadioButton jrbtnAccionActor;
    private javax.swing.JRadioButton jrbtnAccionSistema;
    private javax.swing.JRadioButton jrbtnInclusionExtension;
    private javax.swing.JTextArea jtxaAccion;
    private javax.swing.JTextArea jtxaComentarios;
    private javax.swing.JTextArea jtxaCondicion;
    private javax.swing.JTextField jtxtActor;
    private javax.swing.JTextField jtxtId;
    private javax.swing.JTextField jtxtInclusion;
    private javax.swing.JTextField jtxtTerminacion;
    private javax.swing.JTextField jtxtUnidad;
    private javax.swing.JTextField jtxtValor;
    // End of variables declaration//GEN-END:variables

    /**
     * Muestra un mensaje en un JOptionPane
     * @param mensaje a mostrar en el JOptionPane
     */
    private void mostrarmensaje(String mensaje) {
                JOptionPane.showMessageDialog(this, mensaje, "Advertencia",
                        JOptionPane.WARNING_MESSAGE);
    }

    /**
     * update Método que es llamado cuando el objeto observado cambia
     * @param o objeto observable
     * @param arg argumento pasado al método notifyObservers
     */
    public void update(Observable o, Object arg) {
        jtxaCondicion.setText(String.valueOf(newExCU.getCondicion()));
        jtxtTerminacion.setText(String.valueOf(newExCU.getTerminacion()));
        jrbtnAccionSistema.setSelected(newExCU.getAccionSistema());
        jrbtnAccionActor.setSelected(newExCU.getAccionActor());
        jtxtActor.setText(String.valueOf(newExCU.getActor()));
        jrbtnInclusionExtension.setSelected(newExCU.getInclusionExtension());
        jtxtInclusion.setText(String.valueOf(newExCU.getIE()));
        jtxaAccion.setText(String.valueOf(newExCU.getAccion()));
        jtxtValor.setText(String.valueOf(newExCU.getValor()));
        jtxtUnidad.setText(String.valueOf(newExCU.getUnidad()));
        jtxaComentarios.setText(String.valueOf(newExCU.getComentario()));
    }

}
