/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * jfrmDatoEspecifico.java
 *
 * Created on 14-dic-2011, 16:11:43
 */

package vista;

import java.util.ArrayList;
import java.util.Observable;
import java.util.Observer;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import modelo.*;

/**
 * jfrmParticipante es el formulario con el cual podremos insertar todas las variables del participante
 */
public class jfrmParticipante extends javax.swing.JFrame implements Observer {

    ArrayList<Organizacion> org = new ArrayList<Organizacion>();
    DocumentoReq auxDocPpal;
    RequisitoInformacion auxRI;
    Participante newParti;
    jfrmPrincipal jfaux;
    MutableTreeNode auxinsertNode;
    int auxinsertIndex;
    private int insertIndex;
    private boolean editar=false;
    MutableTreeNode parent;
    int insertIndex2;
    String Organi;
    ArrayList<String> auxParti = new ArrayList<String>();

    /**
     * Constructor de JFrame Participante
     * @param jf es el formulario principal
     * @param docPpal es el documento donde se guardan todas las variables
     * @param insertNode el nodo a insertar
     * @param insertIndex insertIndex el indice del nodo a insertar
     */
    public jfrmParticipante(jfrmPrincipal jf, DocumentoReq docPpal, MutableTreeNode insertNode, int insertIndex) {
        auxinsertNode = insertNode;
        auxinsertIndex = insertIndex;
        jfaux = jf;
        auxDocPpal = docPpal;
        this.setIconImage(new ImageIcon("src/imagenes/participante.jpg").getImage());
        initComponents();
        int l = 0, i=0;
        int cont = auxDocPpal.getLIdentPA().size();
        i = auxDocPpal.getParticipante().size();
        if (i == cont) {
            i = i + 1;
        } else {
            for (l = 0; l < cont; l++) {
                if (auxDocPpal.getLIdentPA().get(l) == 0) {
                    i = l + 1;
                }
            }
        }
        String ident;
        ident ="PART"+String.valueOf(i);
        jtxtId.setText(ident);
        org = auxDocPpal.getOrganizacion();
        for(i = 0; i < org.size(); i++){
            jcbOrganización.addItem(org.get(i).getIdent());
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jtxtNombre = new javax.swing.JTextField();
        jlbRol = new javax.swing.JLabel();
        jtxtRol = new javax.swing.JTextField();
        jlbOrganización = new javax.swing.JLabel();
        jcbOrganización = new javax.swing.JComboBox();
        jlbTipo = new javax.swing.JLabel();
        jchbCliente = new javax.swing.JCheckBox();
        jchbDesarrollador = new javax.swing.JCheckBox();
        jchbUsuario = new javax.swing.JCheckBox();
        jLabel12 = new javax.swing.JLabel();
        jtxtId = new javax.swing.JTextField();
        jbtnAceptar = new javax.swing.JButton();
        jbtnCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Participante");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jLabel1.setText("Nombre");

        jlbRol.setText("Rol");

        jlbOrganización.setText("Organización");

        jcbOrganización.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "-------" }));

        jlbTipo.setText("Tipo de participante");

        jchbCliente.setText("El participante es un cliente");

        jchbDesarrollador.setText("El participante es un desarrollador");

        jchbUsuario.setText("El participante es un usuario");

        jLabel12.setText("Identificador:");

        jtxtId.setEditable(false);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jchbUsuario)
                            .addComponent(jchbDesarrollador)
                            .addComponent(jlbOrganización)
                            .addComponent(jcbOrganización, javax.swing.GroupLayout.PREFERRED_SIZE, 266, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jlbTipo)
                            .addComponent(jchbCliente))
                        .addContainerGap(54, Short.MAX_VALUE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jlbRol, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jtxtRol, javax.swing.GroupLayout.PREFERRED_SIZE, 251, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(50, 50, 50))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jtxtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, 165, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(114, Short.MAX_VALUE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, 65, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jtxtId, javax.swing.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE)
                        .addGap(153, 153, 153))))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtxtId)
                    .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel1)
                    .addComponent(jtxtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtxtRol, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jlbRol))
                .addGap(1, 1, 1)
                .addComponent(jlbOrganización, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jcbOrganización, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jlbTipo)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jchbCliente)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jchbDesarrollador)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jchbUsuario)
                .addContainerGap(9, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("General", jPanel1);

        jbtnAceptar.setText("Aceptar");
        jbtnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAceptarActionPerformed(evt);
            }
        });

        jbtnCancelar.setText("Cancelar");
        jbtnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 335, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jbtnAceptar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jbtnCancelar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(15, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(25, 25, 25)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 264, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jbtnAceptar)
                        .addGap(18, 18, 18)
                        .addComponent(jbtnCancelar)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * editarPropiedades Método que edita las propiedades de un participante
     * @param Part participante para editar
     */
    void editarPropiedades(Participante Part) {
        editar = true;
        jtxtId.setText(Part.getIdent());
        jtxtNombre.setText(Part.getNombre());
        jtxtRol.setText(Part.getRol());
        jcbOrganización.setSelectedItem(Part.getOrga());
        Organi = Part.getOrga();
        jchbCliente.setSelected(Part.getEsCliente());
        jchbDesarrollador.setSelected(Part.getEsDesarrollador());
        jchbUsuario.setSelected(Part.getEsUsuario());
    }

    /**
     * jbtnAceptarActionPerformed Activa el boton aceptar
     * @param evt
     */
    private void jbtnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAceptarActionPerformed
        String ident;
        int i, j=0, l=0;
        ident=jtxtId.getText();
        if (!editar) {
            int cont = auxDocPpal.getLIdentPA().size();
            i = auxDocPpal.getParticipante().size();
            if (i == cont) {
                i = i + 1;
                auxDocPpal.getLIdentPA().add(1);
            } else {
                for (l = 0; l < cont; l++) {
                    if (auxDocPpal.getLIdentPA().get(l) == 0) {
                        i = l + 1;
                        auxDocPpal.getLIdentPA().set(l, 1);
                    }
                }
            }
            String orga;
            if(jcbOrganización.getSelectedItem().toString().equals("-------")){
                orga="";

            }else{
                orga=jcbOrganización.getSelectedItem().toString();
            }
            newParti = auxDocPpal.nuevoPart(i, jtxtNombre.getText(), jtxtRol.getText(), orga, jchbCliente.isSelected(), jchbDesarrollador.isSelected(), jchbUsuario.isSelected());
            MutableTreeNode node = new DefaultMutableTreeNode(newParti.getIdent());
            DefaultTreeModel model = (DefaultTreeModel) jfaux.getJtreDocumento().getModel();
            model.insertNodeInto(node, auxinsertNode, auxinsertIndex);
            jfaux.LeeArbol();
            mostrarmensaje("Insertado el Participante " + newParti.getNombre());
            jfaux.setEnabled(true);
            this.dispose();
        } else {
            boolean encontrado = false;
            i = 0;
            while (i < auxDocPpal.getParticipante().size() && encontrado == false) {
                if (auxDocPpal.getParticipante().get(i).getIdent().equals(ident)) {
                    encontrado = true;
                    j = i;
                    auxDocPpal.getParticipante().remove(i);
                    newParti = auxDocPpal.nuevoPart(j+1, jtxtNombre.getText(), jtxtRol.getText(), jcbOrganización.getToolTipText(), jchbCliente.isSelected(), jchbDesarrollador.isSelected(), jchbUsuario.isSelected());
                }
                i++;
            }
            
            jfaux.LeeArbol();
            mostrarmensaje("Insertado el Participante " + newParti.getNombre());
            jfaux.setEnabled(true);
            this.dispose();
        }
}//GEN-LAST:event_jbtnAceptarActionPerformed

    /**
     * jbtnCancelarActionPerformed Activa el boton cancelar
     * @param evt
     */
    private void jbtnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnCancelarActionPerformed
        jfaux.LeeArbol();
        jfaux.setEnabled(true);
        this.dispose();
}//GEN-LAST:event_jbtnCancelarActionPerformed

    /**
     * formWindowClosed es el metodo que se activa cuando pulsamos la x de cerrar
     * @param evt
     */
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_formWindowClosed

    /**
    * @param args the command line arguments
    */
    /*public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
    public void run() {
    new jfrmDatoEspecifico().setVisible(true);
    }
    });
    }*/

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JButton jbtnAceptar;
    private javax.swing.JButton jbtnCancelar;
    private javax.swing.JComboBox jcbOrganización;
    private javax.swing.JCheckBox jchbCliente;
    private javax.swing.JCheckBox jchbDesarrollador;
    private javax.swing.JCheckBox jchbUsuario;
    private javax.swing.JLabel jlbOrganización;
    private javax.swing.JLabel jlbRol;
    private javax.swing.JLabel jlbTipo;
    private javax.swing.JTextField jtxtId;
    private javax.swing.JTextField jtxtNombre;
    private javax.swing.JTextField jtxtRol;
    // End of variables declaration//GEN-END:variables

    /**
     * Muestra un mensaje en un JOptionPane
     * @param mensaje a mostrar en el JOptionPane
     */
    private void mostrarmensaje(String mensaje) {
        JOptionPane.showMessageDialog(this, mensaje, "Advertencia",
                                JOptionPane.WARNING_MESSAGE);
    }

    /**
     * update Método que es llamado cuando el objeto observado cambia
     * @param o objeto observable
     * @param arg argumento pasado al método notifyObservers
     */
    public void update(Observable o, Object arg) {
        jtxtNombre.setText(String.valueOf(newParti.getNombre()));
        jtxtRol.setText(String.valueOf(newParti.getRol()));
        jcbOrganización.setSelectedItem(String.valueOf(newParti.getOrga()));
        jchbCliente.setSelected(newParti.getEsCliente());
        jchbDesarrollador.setSelected(newParti.getEsDesarrollador());
        jchbUsuario.setSelected(newParti.getEsUsuario());
    }
}
