/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * jfrmPrincipal.java
 *
 * Created on 15-nov-2011, 16:34:51
 */
package vista;

import imagenes.RendererArbol;
import java.awt.event.ActionEvent;
import java.io.*;
import java.util.*;
import java.util.logging.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.xml.transform.stream.*;
import javax.xml.transform.*;
import modelo.*;

/**
 * jfrmPrincipal es el formulario con todas las opciones posibles del programa
 */
public class jfrmPrincipal extends javax.swing.JFrame implements Observer {

    String xslOrigen= "src/modelo/XMLDocumentoReq1.xsl";
    private boolean estiloPredet=true;
    int auxps = -1;
    DocumentoReq docPpal = new DocumentoReq();
    GestorDocus auxGD = new GestorDocus();
    FiltroHTML filtroHtml = new FiltroHTML();
    Filtro filtro = new Filtro();
    CasodeUso CU = new CasodeUso();
    PasoCU PS = new PasoCU();
    ExcepcionCU EX = new ExcepcionCU();
    Objetivo Ob = new Objetivo();
    RequisitoInformacion RI = new RequisitoInformacion();
    String Fila;
    String Columna;
    ActionEvent evt;
    String resultado;
    /** Creates new form jfrmPrincipal */


    /**
     * Constructor de JFrame Principal
     */
    @SuppressWarnings("static-access")
    public jfrmPrincipal(String aresultado) {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            e.printStackTrace();
        }
        this.setIconImage(new ImageIcon("src/imagenes/rem.jpg").getImage());
        initComponents();
        TreePath tp = getJtreDocumento().getPathForRow(0);
        MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
        MutableTreeNode node = new DefaultMutableTreeNode();
        MutableTreeNode node2 = new DefaultMutableTreeNode();
        MutableTreeNode node3 = new DefaultMutableTreeNode();
        docPpal.setCasodeUso(CU.getData("CasodeUso"));
        List<PasoCU> pasos = PS.getData("PasoCU");
        List<ExcepcionCU> excepciones = EX.getData("ExcepcionCU");
        for (int i=0; i < docPpal.getCasodeUso().size(); i++){
            if(docPpal.getCasodeUso().size()>0){
                int insertIndex = 0;
                node = new DefaultMutableTreeNode(docPpal.getCasodeUso().get(i).getIdent());
                DefaultTreeModel model = (DefaultTreeModel) this.getJtreDocumento().getModel();
                model.insertNodeInto(node, insertNode, insertIndex);
            }
            for (int ps = 0; ps < pasos.size(); ps++) {
                if (pasos.get(ps).getIdent().endsWith(docPpal.getCasodeUso().get(i).getIdent())) {
                    docPpal.getCasodeUso().get(i).getPasoCU().add(pasos.get(ps));
                }
            }
            for (int j=0; j < docPpal.getCasodeUso().get(i).getPasoCU().size(); j++){
                if (docPpal.getCasodeUso().get(i).getPasoCU().size() > 0) {
                    node2 = new DefaultMutableTreeNode(docPpal.getCasodeUso().get(i).getPasoCU().get(j).getIdent());
                    node.insert(node2, i);
                }
                for (int ex = 0; ex < excepciones.size(); ex++) {
                    if (excepciones.get(ex).getIdent().endsWith(docPpal.getCasodeUso().get(i).getPasoCU().get(j).getIdent())) {
                        docPpal.getCasodeUso().get(i).getPasoCU().get(j).getExcepcionCU().add(excepciones.get(ex));
                    }
                }
                for(int k=0; k < docPpal.getCasodeUso().get(i).getPasoCU().get(j).getExcepcionCU().size(); k++){
                    if (docPpal.getCasodeUso().get(i).getPasoCU().get(j).getExcepcionCU().size() > 0) {
                        node3 = new DefaultMutableTreeNode(docPpal.getCasodeUso().get(i).getPasoCU().get(j).getExcepcionCU().get(k).getIdent());
                        node2.insert(node3, i);
                    }
                }
            }
        }
        resultado = aresultado;
        docPpal.setId_n(1);
        docPpal.setNombre("SinNombre");
        docPpal.setCreador("?");
        docPpal.setFecha("?");
        docPpal.setPreparado("?");
        this.getJtreDocumento().setCellRenderer(new RendererArbol());
        this.getJtreDocumento().getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        this.jtxpDocumento.setContentType("text/html");
        LeeArbol();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jppupMenu = new javax.swing.JPopupMenu();
        jmniEliminar = new javax.swing.JMenuItem();
        jmniEditar = new javax.swing.JMenuItem();
        jmniSUBO = new javax.swing.JMenuItem();
        jmniDE = new javax.swing.JMenuItem();
        jmniExcepcion1 = new javax.swing.JMenuItem();
        jmniPaso1 = new javax.swing.JMenuItem();
        jToolBar1 = new javax.swing.JToolBar();
        jbtnSeccion = new javax.swing.JButton();
        jbtnParrafo = new javax.swing.JButton();
        jbtnFicheroGrafico = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JToolBar.Separator();
        jbtnOrganizacion = new javax.swing.JButton();
        jbtnParticipante = new javax.swing.JButton();
        jbtnReunion = new javax.swing.JButton();
        jSeparator2 = new javax.swing.JToolBar.Separator();
        jbtnReqRestriccion = new javax.swing.JButton();
        jbtnReqInformacion = new javax.swing.JButton();
        jbtnReqFuncional = new javax.swing.JButton();
        jbtnReqNoFuncional = new javax.swing.JButton();
        jbtnDatoEspecifico = new javax.swing.JButton();
        jSeparator3 = new javax.swing.JToolBar.Separator();
        jbtnActor = new javax.swing.JButton();
        jbtnObjetivo = new javax.swing.JButton();
        jbtnSubobjetivo = new javax.swing.JButton();
        jSeparator4 = new javax.swing.JToolBar.Separator();
        jbtnMatrizRastreabilidad = new javax.swing.JButton();
        jInternalFrame1 = new javax.swing.JInternalFrame();
        jScrollPane2 = new javax.swing.JScrollPane();
        jtxpDocumento = new javax.swing.JTextPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtreDocumento = new javax.swing.JTree();
        jlblMensaje = new javax.swing.JLabel();
        jmnuBarraPpal = new javax.swing.JMenuBar();
        jmnuArchivo = new javax.swing.JMenu();
        jmniNuevo = new javax.swing.JMenuItem();
        jmniAbrir = new javax.swing.JMenuItem();
        jmniGuardar = new javax.swing.JMenuItem();
        jmniGuardarHTML = new javax.swing.JMenuItem();
        jmnuCU = new javax.swing.JMenu();
        jmniNuevoCU = new javax.swing.JMenuItem();
        jmniPaso = new javax.swing.JMenuItem();
        jmniExcepcion = new javax.swing.JMenuItem();
        jmnuHerramientas = new javax.swing.JMenu();
        jmniLeeArbol = new javax.swing.JMenuItem();
        jmniXSL = new javax.swing.JMenuItem();
        jmnuSalir = new javax.swing.JMenu();
        jmniSalir = new javax.swing.JMenuItem();

        jppupMenu.addPopupMenuListener(new javax.swing.event.PopupMenuListener() {
            public void popupMenuCanceled(javax.swing.event.PopupMenuEvent evt) {
            }
            public void popupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {
            }
            public void popupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {
                jppupMenuPopupMenuWillBecomeVisible(evt);
            }
        });

        jmniEliminar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/eliminar.jpg"))); // NOI18N
        jmniEliminar.setText("Eliminar");
        jmniEliminar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jmniEliminarActionPerformed(evt);
            }
        });
        jppupMenu.add(jmniEliminar);

        jmniEditar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/editar.jpg"))); // NOI18N
        jmniEditar.setText("Editar propiedades");
        jmniEditar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jmniEditarActionPerformed(evt);
            }
        });
        jppupMenu.add(jmniEditar);

        jmniSUBO.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/subobjetivo.jpg"))); // NOI18N
        jmniSUBO.setText("Subobjetivo");
        jmniSUBO.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jmniSUBOActionPerformed(evt);
            }
        });
        jppupMenu.add(jmniSUBO);

        jmniDE.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/datoEspecifico.jpg"))); // NOI18N
        jmniDE.setText("Dato especifico");
        jmniDE.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jmniDEActionPerformed(evt);
            }
        });
        jppupMenu.add(jmniDE);

        jmniExcepcion1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/excepcion.jpg"))); // NOI18N
        jmniExcepcion1.setText("Excepción");
        jmniExcepcion1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jmniExcepcion1ActionPerformed(evt);
            }
        });
        jppupMenu.add(jmniExcepcion1);

        jmniPaso1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/paso.jpg"))); // NOI18N
        jmniPaso1.setText("Paso");
        jmniPaso1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jmniPaso1ActionPerformed(evt);
            }
        });
        jppupMenu.add(jmniPaso1);

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Documento de Requisitos");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jbtnSeccion.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/seccion.jpg"))); // NOI18N
        jbtnSeccion.setToolTipText("Seccion/Apendice");
        jbtnSeccion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnSeccionActionPerformed(evt);
            }
        });
        jToolBar1.add(jbtnSeccion);

        jbtnParrafo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/parrafo.jpg"))); // NOI18N
        jbtnParrafo.setToolTipText("Parrafo/Glosario");
        jbtnParrafo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnParrafoActionPerformed(evt);
            }
        });
        jToolBar1.add(jbtnParrafo);

        jbtnFicheroGrafico.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/ficherografico.JPG"))); // NOI18N
        jbtnFicheroGrafico.setToolTipText("Fichero Gráfico");
        jbtnFicheroGrafico.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnFicheroGraficoActionPerformed(evt);
            }
        });
        jToolBar1.add(jbtnFicheroGrafico);
        jToolBar1.add(jSeparator1);

        jbtnOrganizacion.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/organizacion.jpg"))); // NOI18N
        jbtnOrganizacion.setToolTipText("Organización");
        jbtnOrganizacion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnOrganizacionActionPerformed(evt);
            }
        });
        jToolBar1.add(jbtnOrganizacion);

        jbtnParticipante.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/participante.jpg"))); // NOI18N
        jbtnParticipante.setToolTipText("Participante");
        jbtnParticipante.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnParticipanteActionPerformed(evt);
            }
        });
        jToolBar1.add(jbtnParticipante);

        jbtnReunion.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/reunion.jpg"))); // NOI18N
        jbtnReunion.setToolTipText("Reunión");
        jbtnReunion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnReunionActionPerformed(evt);
            }
        });
        jToolBar1.add(jbtnReunion);
        jToolBar1.add(jSeparator2);

        jbtnReqRestriccion.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/restriccion.jpg"))); // NOI18N
        jbtnReqRestriccion.setToolTipText("Requisito Restricción");
        jbtnReqRestriccion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnReqRestriccionActionPerformed(evt);
            }
        });
        jToolBar1.add(jbtnReqRestriccion);

        jbtnReqInformacion.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/informacion.jpg"))); // NOI18N
        jbtnReqInformacion.setToolTipText("Requisito Información");
        jbtnReqInformacion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnReqInformacionActionPerformed(evt);
            }
        });
        jToolBar1.add(jbtnReqInformacion);

        jbtnReqFuncional.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/funcional.jpg"))); // NOI18N
        jbtnReqFuncional.setToolTipText("Resuisito Funcional");
        jbtnReqFuncional.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnReqFuncionalActionPerformed(evt);
            }
        });
        jToolBar1.add(jbtnReqFuncional);

        jbtnReqNoFuncional.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/nofuncional.jpg"))); // NOI18N
        jbtnReqNoFuncional.setToolTipText("Requisito no Funcional");
        jbtnReqNoFuncional.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnReqNoFuncionalActionPerformed(evt);
            }
        });
        jToolBar1.add(jbtnReqNoFuncional);

        jbtnDatoEspecifico.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/datoEspecifico.jpg"))); // NOI18N
        jbtnDatoEspecifico.setToolTipText("Dato Especifico");
        jbtnDatoEspecifico.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnDatoEspecificoActionPerformed(evt);
            }
        });
        jToolBar1.add(jbtnDatoEspecifico);
        jToolBar1.add(jSeparator3);

        jbtnActor.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/actor.jpg"))); // NOI18N
        jbtnActor.setToolTipText("Actor");
        jbtnActor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnActorActionPerformed(evt);
            }
        });
        jToolBar1.add(jbtnActor);

        jbtnObjetivo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/objetivo.jpg"))); // NOI18N
        jbtnObjetivo.setToolTipText("Objetivo");
        jbtnObjetivo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnObjetivoActionPerformed(evt);
            }
        });
        jToolBar1.add(jbtnObjetivo);

        jbtnSubobjetivo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/subobjetivo.jpg"))); // NOI18N
        jbtnSubobjetivo.setToolTipText("Subobjetivo");
        jbtnSubobjetivo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnSubobjetivoActionPerformed(evt);
            }
        });
        jToolBar1.add(jbtnSubobjetivo);
        jToolBar1.add(jSeparator4);

        jbtnMatrizRastreabilidad.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/matrizRastr.jpg"))); // NOI18N
        jbtnMatrizRastreabilidad.setToolTipText("Matriz Rastreabilidad");
        jbtnMatrizRastreabilidad.setFocusable(false);
        jbtnMatrizRastreabilidad.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jbtnMatrizRastreabilidad.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jbtnMatrizRastreabilidad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnMatrizRastreabilidadActionPerformed(evt);
            }
        });
        jToolBar1.add(jbtnMatrizRastreabilidad);

        jInternalFrame1.setVisible(true);

        jtxpDocumento.setContentType("text/html");
        jtxpDocumento.setEditable(false);
        jScrollPane2.setViewportView(jtxpDocumento);

        javax.swing.tree.DefaultMutableTreeNode treeNode1 = new javax.swing.tree.DefaultMutableTreeNode("Documento ER");
        jtreDocumento.setModel(new javax.swing.tree.DefaultTreeModel(treeNode1));
        jtreDocumento.setComponentPopupMenu(jppupMenu);
        jScrollPane1.setViewportView(jtreDocumento);

        javax.swing.GroupLayout jInternalFrame1Layout = new javax.swing.GroupLayout(jInternalFrame1.getContentPane());
        jInternalFrame1.getContentPane().setLayout(jInternalFrame1Layout);
        jInternalFrame1Layout.setHorizontalGroup(
            jInternalFrame1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 747, Short.MAX_VALUE)
            .addGroup(jInternalFrame1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(jInternalFrame1Layout.createSequentialGroup()
                    .addContainerGap()
                    .addGroup(jInternalFrame1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 197, Short.MAX_VALUE)
                        .addComponent(jlblMensaje, javax.swing.GroupLayout.PREFERRED_SIZE, 197, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 524, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        jInternalFrame1Layout.setVerticalGroup(
            jInternalFrame1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 485, Short.MAX_VALUE)
            .addGroup(jInternalFrame1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(jInternalFrame1Layout.createSequentialGroup()
                    .addContainerGap()
                    .addGroup(jInternalFrame1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jInternalFrame1Layout.createSequentialGroup()
                            .addComponent(jlblMensaje, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGap(5, 5, 5)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 437, Short.MAX_VALUE))
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 463, Short.MAX_VALUE))
                    .addContainerGap()))
        );

        jmnuArchivo.setText("Archivo");

        jmniNuevo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/nuevo.jpg"))); // NOI18N
        jmniNuevo.setText("Nuevo");
        jmniNuevo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jmniNuevoActionPerformed(evt);
            }
        });
        jmnuArchivo.add(jmniNuevo);

        jmniAbrir.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/abrir.jpg"))); // NOI18N
        jmniAbrir.setText("Abrir");
        jmniAbrir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jmniAbrirActionPerformed(evt);
            }
        });
        jmnuArchivo.add(jmniAbrir);

        jmniGuardar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/guardar.jpg"))); // NOI18N
        jmniGuardar.setText("Guardar");
        jmniGuardar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jmniGuardarActionPerformed(evt);
            }
        });
        jmnuArchivo.add(jmniGuardar);

        jmniGuardarHTML.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/html.jpg"))); // NOI18N
        jmniGuardarHTML.setText("Guardar HTML");
        jmniGuardarHTML.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jmniGuardarHTMLActionPerformed(evt);
            }
        });
        jmnuArchivo.add(jmniGuardarHTML);

        jmnuBarraPpal.add(jmnuArchivo);

        jmnuCU.setText("CU");

        jmniNuevoCU.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/casouso.jpg"))); // NOI18N
        jmniNuevoCU.setText("Nuevo CU");
        jmniNuevoCU.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jmniNuevoCUActionPerformed(evt);
            }
        });
        jmnuCU.add(jmniNuevoCU);

        jmniPaso.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/paso.jpg"))); // NOI18N
        jmniPaso.setText("Paso");
        jmniPaso.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jmniPasoActionPerformed(evt);
            }
        });
        jmnuCU.add(jmniPaso);

        jmniExcepcion.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/excepcion.jpg"))); // NOI18N
        jmniExcepcion.setText("Excepción");
        jmniExcepcion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jmniExcepcionActionPerformed(evt);
            }
        });
        jmnuCU.add(jmniExcepcion);

        jmnuBarraPpal.add(jmnuCU);

        jmnuHerramientas.setText("Herramientas");

        jmniLeeArbol.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/leer.jpg"))); // NOI18N
        jmniLeeArbol.setText("Leer árbol");
        jmniLeeArbol.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jmniLeeArbolActionPerformed(evt);
            }
        });
        jmnuHerramientas.add(jmniLeeArbol);

        jmniXSL.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/xsl.jpg"))); // NOI18N
        jmniXSL.setText("Seleccionar XSL");
        jmniXSL.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jmniXSLActionPerformed(evt);
            }
        });
        jmnuHerramientas.add(jmniXSL);

        jmnuBarraPpal.add(jmnuHerramientas);

        jmnuSalir.setText("Salir");

        jmniSalir.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/exit.jpg"))); // NOI18N
        jmniSalir.setText("Salir");
        jmniSalir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jmniSalirActionPerformed(evt);
            }
        });
        jmnuSalir.add(jmniSalir);

        jmnuBarraPpal.add(jmnuSalir);

        setJMenuBar(jmnuBarraPpal);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jToolBar1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 783, Short.MAX_VALUE)
            .addGroup(layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(jInternalFrame1)
                .addGap(10, 10, 10))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jToolBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jInternalFrame1)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * jbtnParrafoActionPerformed Activa el boton parrafo
     * @param evt
     */
    private void jbtnParrafoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnParrafoActionPerformed
        TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione un nodo, antes");
          } else {
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              String NomC = insertNode.toString();
              if (!NomC.startsWith("Do")) {
                  jlblMensaje.setText("Seleccione el Documento de requisitos");
              } else {
                  int insertIndex = 0;
                  if (insertNode.getParent() != null) {
                      MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                      insertIndex = parent.getIndex(insertNode) + 1;
                      insertNode = parent;
                  }
                  jfrmParrafo jfParr = new jfrmParrafo(this, docPpal, insertNode, insertIndex);
                  jfParr.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfParr);
              }
          }
}//GEN-LAST:event_jbtnParrafoActionPerformed

    /**
     * LeeArbol es el metodo para llamar a transformar y pasar la información del arbol al jtxpDocumento
     */
    public void LeeArbol(){
        try {
            docPpal.toXML();
            resultado = transformar();
            jtxpDocumento.setText(resultado.toString());
        } catch (Exception e) {
            Logger.getLogger(jfrmPrincipal.class.getName()).log(Level.SEVERE, null, e);
        }
    }

    /**
     * transformar es el metodo que transforma el resultado a xml legible por html
     * @return devuleve el resultado transformado
     * @throws java.lang.Exception
     */
    public String transformar() throws Exception {
        String xmlOrigen = "resultado.xml";
        if(estiloPredet){
            xslOrigen = "src/modelo/XMLDocumentoReq1.xsl";
        }else{
            xslOrigen = "src/modelo/XMLDocumentoReq2.xsl";
        }
        Source xmlSource = new StreamSource(new File(xmlOrigen));
        Source xsltSource = new StreamSource(new File(xslOrigen));
        StringWriter cadenaSalida = new StringWriter();
        Result bufferResultado = new StreamResult(cadenaSalida);
        TransformerFactory factoriaTrans = TransformerFactory.newInstance();
        Transformer transformador = factoriaTrans.newTransformer(xsltSource);
        transformador.transform(xmlSource, bufferResultado);

        return cadenaSalida.toString();
    }

    /**
     * jmniNuevoCUActionPerformed Activa el menu item caso de uso
     * @param evt
     */
    private void jmniNuevoCUActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jmniNuevoCUActionPerformed
        TreePath tp = getJtreDocumento().getSelectionPath();
        if (tp == null) {
            jlblMensaje.setText("Seleccione el Documento de requisitos");
        } else {
            MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
            String NomC = insertNode.toString();
            if (!NomC.startsWith("Do")) {
                jlblMensaje.setText("Seleccione el Documento de requisitos");
            } else {
                int insertIndex = 0;
                if (insertNode.getParent() != null) {
                    MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                    insertIndex = parent.getIndex(insertNode) + 1;
                    insertNode = parent;
                }
                jfrmCasodeUso jfCU = new jfrmCasodeUso(this, docPpal, insertNode, insertIndex);

                jfCU.setVisible(true);
                this.setEnabled(false);
                jlblMensaje.setText("");
                docPpal.addObserver(jfCU);
            }
        }

}//GEN-LAST:event_jmniNuevoCUActionPerformed

    /**
     * jmniSalirActionPerformed Activa el menu item salir
     * @param evt
     */
    private void jmniSalirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jmniSalirActionPerformed
        mostrarMensaje("Desea guardar el documento");
        this.setEnabled(true);
    }//GEN-LAST:event_jmniSalirActionPerformed

    /**
     * jmniPasoActionPerformed Activa el menu item paso
     * @param evt
     */
    private void jmniPasoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jmniPasoActionPerformed

        TreePath tp = getJtreDocumento().getSelectionPath();
        if (tp == null) {
            jlblMensaje.setText("Seleccione un documento de requisitos");
        } else {
            MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
            String NomC = insertNode.toString();
            if (!NomC.startsWith("CU")) {
                jlblMensaje.setText("Seleccione un Caso de Uso");
            } else {
                int insertIndex = 0;
                for (int i=0; i<docPpal.getCasodeUso().size();i++){
                    if(docPpal.getCasodeUso().get(i).getIdent().equals(NomC)){
                        CU=docPpal.getCasodeUso().get(i);
                    }
                }
                jfrmPaso jfPaso = new jfrmPaso(this, docPpal, insertNode, insertIndex, CU);

                jfPaso.setVisible(true);
                this.setEnabled(false);
                jlblMensaje.setText("");
                docPpal.addObserver(jfPaso);
            }
        }
    }//GEN-LAST:event_jmniPasoActionPerformed

    /**
     * jmniExcepcionActionPerformed Activa el menu item excepcion
     * @param evt
     */
      private void jmniExcepcionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jmniExcepcionActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione un documento de requisitos");
          } else {
              String NomC;
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              NomC = insertNode.toString();
              if (!NomC.startsWith("PCU")) {
                  jlblMensaje.setText("Seleccione un paso");
              } else {
                  int insertIndex = 0;
                  for (int i = 0; i < docPpal.getCasodeUso().size(); i++) {
                      for (int j = 0; j < docPpal.getCasodeUso().get(i).getPasoCU().size(); j++) {
                          if (docPpal.getCasodeUso().get(i).getPasoCU().get(j).getIdent().equals(NomC)) {
                              CU = docPpal.getCasodeUso().get(i);
                              PS = docPpal.getCasodeUso().get(i).getPasoCU().get(j);
                              auxps = j;
                          }
                      }
                  }
                  jfrmExcepcionCU jfexpCU = new jfrmExcepcionCU(this, docPpal, insertNode, insertIndex, CU, PS, auxps);
                  jfexpCU.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfexpCU);
              }
          }
      }//GEN-LAST:event_jmniExcepcionActionPerformed

      /**
       * jbtnReqInformacionActionPerformed Activa el boton requisito de informacion
       * @param evt
       */
      private void jbtnReqInformacionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnReqInformacionActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione un documento de requisitos");
          } else {
              String NomC;
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              NomC = insertNode.toString();
              if (!NomC.startsWith("Do")) {
                  jlblMensaje.setText("Seleccione el documento de requisitos");
              } else {
                  int insertIndex = 0;
                  jfrmReqInformacion jfReqInfo = new jfrmReqInformacion(this, docPpal, insertNode, insertIndex);
                  jfReqInfo.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfReqInfo);
              }
          }
}//GEN-LAST:event_jbtnReqInformacionActionPerformed

      /**
       * jbtnReqRestriccionActionPerformed Activa el boton requisto de restriccion
       * @param evt
       */
      private void jbtnReqRestriccionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnReqRestriccionActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione el Documento de requisitos");
          } else {
              String NomC;
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              NomC = insertNode.toString();
              if (!NomC.startsWith("Do")) {
                  jlblMensaje.setText("Seleccione el documento de requisitos");
              } else {
                  int insertIndex = 0;
                  if (insertNode.getParent() != null) {
                      MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                      insertIndex = parent.getIndex(insertNode) + 1;
                      insertNode = parent;
                  }
                  jfrmReqRestriccion jfRes = new jfrmReqRestriccion(this, docPpal, insertNode, insertIndex);
                  jfRes.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfRes);
              }
          }
      }//GEN-LAST:event_jbtnReqRestriccionActionPerformed

      /**
       * jbtnReqFuncionalActionPerformed Activa el boton requisito funcional
       * @param evt
       */
      private void jbtnReqFuncionalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnReqFuncionalActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione el documento de requisitos");
          } else {
              String NomC;
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              NomC = insertNode.toString();
              if (!NomC.startsWith("Do")) {
                  jlblMensaje.setText("Seleccione el documento de requisitos");
              } else {
                  int insertIndex = 0;
                  jfrmReqFuncional jfReqFunc = new jfrmReqFuncional(this, docPpal, insertNode, insertIndex);
                  jfReqFunc.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfReqFunc);
              }
          }
      }//GEN-LAST:event_jbtnReqFuncionalActionPerformed

      /**
       * jbtnReqNoFuncionalActionPerformed Activa el boton requisito no funcional
       * @param evt
       */
      private void jbtnReqNoFuncionalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnReqNoFuncionalActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione el documento de requisitos");
          } else {
              String NomC;
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              NomC = insertNode.toString();
              if (!NomC.startsWith("Do")) {
                  jlblMensaje.setText("Seleccione el documento de requisitos");
              } else {
                  int insertIndex = 0;
                  jfrmReqNoFuncional jfReqNFunc = new jfrmReqNoFuncional(this, docPpal, insertNode, insertIndex);
                  jfReqNFunc.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfReqNFunc);
              }
          }
      }//GEN-LAST:event_jbtnReqNoFuncionalActionPerformed

      /**
       * jbtnDatoEspecificoActionPerformed Activa el boton dato especifico
       * @param evt
       */
      private void jbtnDatoEspecificoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnDatoEspecificoActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione un documento de requisitos");
          } else {
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              String NomC = insertNode.toString();

              if (!NomC.startsWith("RI")) {
                  jlblMensaje.setText("Seleccione un requisito de informacion");
              } else {
                  boolean encontrado = false;
                  int insertIndex = 0;
                  for (int i = 0; i < docPpal.getRequisitoInformacion().size(); i++) {
                      if (docPpal.getRequisitoInformacion().get(i).getIdent().equals(NomC)) {
                          encontrado = true;
                          RI = docPpal.getRequisitoInformacion().get(i);
                      }
                  }
                  jfrmDatoEspecifico jfDE = new jfrmDatoEspecifico(this, docPpal, insertNode, insertIndex, RI);

                  jfDE.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfDE);
              }
          }
}//GEN-LAST:event_jbtnDatoEspecificoActionPerformed

      /**
       * jbtnActorActionPerformed Activa el boton actor
       * @param evt
       */
      private void jbtnActorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnActorActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione el documento de requisitos");
          } else {
              String NomC;
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              NomC = insertNode.toString();
              if (!NomC.startsWith("Do")) {
                  jlblMensaje.setText("Seleccione el documento de requisitos");
              } else {
                  int insertIndex = 0;
                  jfrmActor jfAct = new jfrmActor(this, docPpal, insertNode, insertIndex);
                  jfAct.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfAct);
              }
          }
      }//GEN-LAST:event_jbtnActorActionPerformed

      /**
       * jbtnObjetivoActionPerformed Activa el boton objetivo
       * @param evt
       */
      private void jbtnObjetivoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnObjetivoActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione el documento de requisitos");
          } else {
              String NomC;
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              NomC = insertNode.toString();
              if (!NomC.startsWith("Do")) {
                  jlblMensaje.setText("Seleccione el documento de requisitos");
              } else {
                  int insertIndex = 0;
                  jfrmObjetivo jfOb = new jfrmObjetivo(this, docPpal, insertNode, insertIndex);
                  jfOb.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfOb);
              }
          }
      }//GEN-LAST:event_jbtnObjetivoActionPerformed

      /**
       * jbtnParticipanteActionPerformed Activa el boton participante
       * @param evt
       */
      private void jbtnParticipanteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnParticipanteActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione el documento de requisitos");
          } else {
              String NomC;
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              NomC = insertNode.toString();
              if (!NomC.startsWith("Do")) {
                  jlblMensaje.setText("Seleccione el documento de requisitos");
              } else {
                  int insertIndex = 0;
                  jfrmParticipante jfPar = new jfrmParticipante(this, docPpal, insertNode, insertIndex);
                  jfPar.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfPar);
              }
          }
      }//GEN-LAST:event_jbtnParticipanteActionPerformed

      /**
       * jbtnReunionActionPerformed Activa el boton reunion
       * @param evt
       */
      private void jbtnReunionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnReunionActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione el documento de requisitos");
          } else {
              String NomC;
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              NomC = insertNode.toString();
              if (!NomC.startsWith("Do")) {
                  jlblMensaje.setText("Seleccione el documento de requisitos");
              } else {
                  int insertIndex = 0;
                  jfrmReunion jfReu = new jfrmReunion(this, docPpal, insertNode, insertIndex);
                  jfReu.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfReu);
              }
          }
      }//GEN-LAST:event_jbtnReunionActionPerformed

      /**
       * jbtnSubobjetivoActionPerformed Activa el boton Subobjetivo
       * @param evt
       */
      private void jbtnSubobjetivoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnSubobjetivoActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione un documento de requisitos");
          } else {
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              String NomC = insertNode.toString();

              if (!NomC.startsWith("OB")) {
                  jlblMensaje.setText("Seleccione un objetivo");
              } else {
                  boolean encontrado = false;
                  int insertIndex = 0;
                  for (int i = 0; i < docPpal.getObjetivo().size(); i++) {
                      if (docPpal.getObjetivo().get(i).getIdent().equals(NomC)) {
                          encontrado = true;
                          Ob = docPpal.getObjetivo().get(i);
                      }
                  }
                  jfrmSubobjetivo jfSubo = new jfrmSubobjetivo(this, docPpal, insertNode, insertIndex, Ob);

                  jfSubo.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfSubo);
              }
          }
      }//GEN-LAST:event_jbtnSubobjetivoActionPerformed

      /**
       * jbtnMatrizRastreabilidadActionPerformed Activa el boton matriz de rastreabilidad
       * @param evt
       */
      private void jbtnMatrizRastreabilidadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnMatrizRastreabilidadActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione el documento de requisitos");
          } else {
              String NomC;
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              NomC = insertNode.toString();
              if (!NomC.startsWith("Do")) {
                  jlblMensaje.setText("Seleccione el documento de requisitos");
              } else {
                  int insertIndex = 0;
                  jfrmMatrizRastreabilidad jfMR = new jfrmMatrizRastreabilidad(this, docPpal, insertNode, insertIndex);
                  jfMR.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfMR);
              }
          }
      }//GEN-LAST:event_jbtnMatrizRastreabilidadActionPerformed

      /**
       * jppupMenuPopupMenuWillBecomeVisible es el metodo para que cuando pulses boton
       * derecho en el jtree salgan los menus que corresponda a cada elemento del jtree
       * @param evt
       */
      private void jppupMenuPopupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {//GEN-FIRST:event_jppupMenuPopupMenuWillBecomeVisible
          TreePath tp = jtreDocumento.getSelectionPath();
          if (tp == null) {
              boton_derecho(-2);
          } else {
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              String NomC = insertNode.toString();
              if (NomC.startsWith("Docu")) {
                  boton_derecho(-1);
              }else{
                  if(NomC.startsWith("CU")){
                      boton_derecho(0);
                  }else{
                      if(NomC.startsWith("PCU")){
                          boton_derecho(1);
                      }else{
                          if(NomC.startsWith("OB")){
                              boton_derecho(2);
                          }else{
                              if(NomC.startsWith("RI")){
                                  boton_derecho(3);
                              }else{
                                  boton_derecho(4);
                              }
                          }
                      }
                  }
              }
          }
}//GEN-LAST:event_jppupMenuPopupMenuWillBecomeVisible

      /**
       * jmniEliminarActionPerformed Activa el menu item eliminar
       * @param evt
       */
      private void jmniEliminarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jmniEliminarActionPerformed
          TreePath tp = jtreDocumento.getSelectionPath();
          MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
          String Nombre = insertNode.toString();

          if (Nombre.startsWith("CU")) {
              List<CasodeUso> casoU = docPpal.getCasodeUso();
              int i = 0;
              boolean encontrado = false;
              while (i < casoU.size() && encontrado == false) {
                  if (casoU.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      docPpal.getCasodeUso().get(i).eliminarBD(docPpal.getCasodeUso().get(i));
                      docPpal.getCasodeUso().remove(i);
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("PCU")) {
              MutableTreeNode auxinsertNode = (MutableTreeNode) tp.getLastPathComponent();
              auxinsertNode = (MutableTreeNode) auxinsertNode.getParent();
              String NomC = auxinsertNode.toString();
              for (int j = 0; j < docPpal.getCasodeUso().size(); j++) {
                  if (docPpal.getCasodeUso().get(j).getIdent().equals(NomC)) {
                      CU = docPpal.getCasodeUso().get(j);
                  }
              }
              List<PasoCU> Paso = CU.getPasoCU();
              int i = 0;
              boolean encontrado = false;
              while (i < Paso.size() && encontrado == false) {
                  if (Paso.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      Paso.get(i).eliminarPBD(CU.getPasoCU().get(i), CU.getIdent());
                      CU.getPasoCU().remove(i);
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("EXCU")) {
              MutableTreeNode auxinsertNode = (MutableTreeNode) tp.getLastPathComponent();
              auxinsertNode = (MutableTreeNode) auxinsertNode.getParent().getParent();
              String NomC1 = auxinsertNode.toString();
              for (int j = 0; j < docPpal.getCasodeUso().size(); j++) {
                  for (int m = 0; m < docPpal.getCasodeUso().get(j).getPasoCU().size(); m++) {
                      if (docPpal.getCasodeUso().get(j).getPasoCU().get(m).getIdent().equals(NomC1)) {
                          CU = docPpal.getCasodeUso().get(j);
                          PS = docPpal.getCasodeUso().get(j).getPasoCU().get(m);
                      }
                  }
              }
              List<ExcepcionCU> ECU = PS.getExcepcionCU();
              int i = 0;
              boolean encontrado = false;
              while (i < ECU.size() && encontrado == false) {
                  if (ECU.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      ECU.get(i).eliminarEBD(PS.getExcepcionCU().get(i), PS.getIdent());
                      PS.getExcepcionCU().remove(i);
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("RR")) {
              ArrayList<RequisitoRestriccion> ReqRes = docPpal.getRequisitoRestriccion();
              int i = 0;
              boolean encontrado = false;
              while (i < ReqRes.size() && encontrado == false) {
                  if (ReqRes.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      docPpal.getRequisitoRestriccion().remove(i);
                      if (docPpal.getRequisitoRestriccion().size()==0) {
                          for (int k=0; k<docPpal.getLIdentRR().size(); k++){
                              docPpal.getLIdentRR().remove(k);
                          }
                      } else {
                          docPpal.getLIdentRR().set(i, 0);
                      }
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("RI")) {
              ArrayList<RequisitoInformacion> ReqInf = docPpal.getRequisitoInformacion();
              int i = 0;
              boolean encontrado = false;
              while (i < ReqInf.size() && encontrado == false) {
                  if (ReqInf.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      docPpal.getRequisitoInformacion().remove(i);
                      if (docPpal.getRequisitoInformacion().size()==0) {
                          for (int k=0; k<docPpal.getLIdentRI().size(); k++){
                              docPpal.getLIdentRI().remove(k);
                          }
                      } else {
                          docPpal.getLIdentRI().set(i, 0);
                      }
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("DAT")) {
              MutableTreeNode auxinsertNode2 = (MutableTreeNode) tp.getLastPathComponent();
              auxinsertNode2 = (MutableTreeNode) auxinsertNode2.getParent();
              String NomC2 = auxinsertNode2.toString();
              for (int j = 0; j < docPpal.getRequisitoInformacion().size(); j++) {
                  if (docPpal.getRequisitoInformacion().get(j).getIdent().equals(NomC2)) {
                      RI = docPpal.getRequisitoInformacion().get(j);
                  }
              }
              ArrayList<DatoEspecifico> DE = RI.getDatoEspecifico();
              int i = 0;
              boolean encontrado = false;
              while (i < DE.size() && encontrado == false) {
                  if (DE.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      RI.getDatoEspecifico().remove(i);
                      if (RI.getDatoEspecifico().size()==0) {
                          for (int k=0; k<RI.getLIdentDE().size(); k++){
                              RI.getLIdentDE().remove(k);
                          }
                      } else {
                          docPpal.getLIdentRI().set(i, 0);
                      }
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("RF")) {
              ArrayList<RequisitoFuncional> ReqFun = docPpal.getRequisitoFuncional();
              int i = 0;
              boolean encontrado = false;
              while (i < ReqFun.size() && encontrado == false) {
                  if (ReqFun.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      docPpal.getRequisitoFuncional().remove(i);
                      if (docPpal.getRequisitoFuncional().size()==0) {
                          for (int k=0; k<docPpal.getLIdentRF().size(); k++){
                              docPpal.getLIdentRF().remove(k);
                          }
                      } else {
                          docPpal.getLIdentRF().set(i, 0);
                      }
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("RNF")) {
              ArrayList<RequisitoNoFuncional> RNF = docPpal.getRequisitoNoFuncional();
              int i = 0;
              boolean encontrado = false;
              while (i < RNF.size() && encontrado == false) {
                  if (RNF.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      docPpal.getRequisitoNoFuncional().remove(i);
                      if (docPpal.getRequisitoNoFuncional().size()==0) {
                          for (int k=0; k<docPpal.getLIdentRNF().size(); k++){
                              docPpal.getLIdentRNF().remove(k);
                          }
                      } else {
                          docPpal.getLIdentRNF().set(i, 0);
                      }
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("ACT")) {
              ArrayList<Actor> Ac = docPpal.getActor();
              int i = 0;
              boolean encontrado = false;
              while (i < Ac.size() && encontrado == false) {
                  if (Ac.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      docPpal.getActor().remove(i);
                      if (docPpal.getActor().size()==0) {
                          for (int k=0; k<docPpal.getLIdentAC().size(); k++){
                              docPpal.getLIdentAC().remove(k);
                          }
                      } else {
                          docPpal.getLIdentAC().set(i, 0);
                      }
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("OB")) {
              ArrayList<Objetivo> ob = docPpal.getObjetivo();
              int i = 0;
              boolean encontrado = false;
              while (i < ob.size() && encontrado == false) {
                  if (ob.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      docPpal.getObjetivo().remove(i);
                      if (docPpal.getObjetivo().size()==0) {
                          for (int k=0; k<docPpal.getLIdentOB().size(); k++){
                              docPpal.getLIdentOB().remove(k);
                          }
                      } else {
                          docPpal.getLIdentOB().set(i, 0);
                      }
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("SUBO")) {
              MutableTreeNode auxinsertNode3 = (MutableTreeNode) tp.getLastPathComponent();
              auxinsertNode3 = (MutableTreeNode) auxinsertNode3.getParent();
              String NomC3 = auxinsertNode3.toString();
              for (int j = 0; j < docPpal.getObjetivo().size(); j++) {
                  if (docPpal.getObjetivo().get(j).getIdent().equals(NomC3)) {
                      Ob = docPpal.getObjetivo().get(j);
                  }
              }
              ArrayList<Subobjetivo> subobj = Ob.getSubobjetivo();
              int i = 0;
              boolean encontrado = false;
              while (i < subobj.size() && encontrado == false) {
                  if (subobj.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      Ob.getSubobjetivo().remove(i);
                      if (Ob.getSubobjetivo().size()==0) {
                          for (int k=0; k<Ob.getLIdentSO().size(); k++){
                              Ob.getLIdentSO().remove(k);
                          }
                      } else {
                          Ob.getLIdentSO().set(i, 0);
                      }
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("PART")) {
              ArrayList<Participante> part = docPpal.getParticipante();
              int i = 0;
              boolean encontrado = false;
              while (i < part.size() && encontrado == false) {
                  if (part.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      docPpal.getParticipante().remove(i);
                      if (docPpal.getParticipante().size()==0) {
                          for (int k=0; k<docPpal.getLIdentPA().size(); k++){
                              docPpal.getLIdentPA().remove(k);
                          }
                      } else {
                          docPpal.getLIdentPA().set(i, 0);
                      }
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("REU")) {
              ArrayList<Reunion> reu = docPpal.getReunion();
              int i = 0;
              boolean encontrado = false;
              while (i < reu.size() && encontrado == false) {
                  if (reu.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      docPpal.getReunion().remove(i);
                      if (docPpal.getReunion().size()==0) {
                          for (int k=0; k<docPpal.getLIdentRE().size(); k++){
                              docPpal.getLIdentRE().remove(k);
                          }
                      } else {
                          docPpal.getLIdentRE().set(i, 0);
                      }
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("PARR")) {
              ArrayList<Parrafo> parr = docPpal.getParrafo();
              int i = 0;
              boolean encontrado = false;
              while (i < parr.size() && encontrado == false) {
                  if (parr.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      docPpal.getParrafo().remove(i);
                      if (docPpal.getParrafo().size()==0) {
                          for (int k=0; k<docPpal.getLIdentPRR().size(); k++){
                              docPpal.getLIdentPRR().remove(k);
                          }
                      } else {
                          docPpal.getLIdentPRR().set(i, 0);
                      }
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("FICH")) {
              ArrayList<FicheroGrafico> fiche = docPpal.getFicheroGrafico();
              int i = 0;
              boolean encontrado = false;
              while (i < fiche.size() && encontrado == false) {
                  if (fiche.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      docPpal.getFicheroGrafico().remove(i);
                      if (docPpal.getFicheroGrafico().size()==0) {
                          for (int k=0; k<docPpal.getLIdentFI().size(); k++){
                              docPpal.getLIdentFI().remove(k);
                          }
                      } else {
                          docPpal.getLIdentFI().set(i, 0);
                      }
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("MAT")) {
              ArrayList<MatrizRastreabilidad> maR = docPpal.getMatrizRastreabilidad();
              int i = 0;
              boolean encontrado = false;
              while (i < maR.size() && encontrado == false) {
                  if (maR.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      docPpal.getMatrizRastreabilidad().remove(i);
                      if (docPpal.getMatrizRastreabilidad().size()==0) {
                          for (int k=0; k<docPpal.getLIdentMR().size(); k++){
                              docPpal.getLIdentMR().remove(k);
                          }
                      } else {
                          docPpal.getLIdentMR().set(i, 0);
                      }
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("SECC")) {
              ArrayList<Seccion> secc = docPpal.getSeccion();
              int i = 0;
              boolean encontrado = false;
              while (i < secc.size() && encontrado == false) {
                  if (secc.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      docPpal.getSeccion().remove(i);
                      if (docPpal.getSeccion().size()==0) {
                          for (int k=0; k<docPpal.getLIdentSE().size(); k++){
                              docPpal.getLIdentSE().remove(k);
                          }
                      } else {
                          docPpal.getLIdentSE().set(i, 0);
                      }
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("ORG")) {
              ArrayList<Organizacion> org = docPpal.getOrganizacion();
              int i = 0;
              boolean encontrado = false;
              while (i < org.size() && encontrado == false) {
                  if (org.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      docPpal.getOrganizacion().remove(i);
                      if (docPpal.getOrganizacion().size()==0) {
                          for (int k=0; k<docPpal.getLIdentOR().size(); k++){
                              docPpal.getLIdentOR().remove(k);
                          }
                      } else {
                          docPpal.getLIdentOR().set(i, 0);
                      }
                      MutableTreeNode parent = (MutableTreeNode)(insertNode.getParent());
                      DefaultTreeModel model = (DefaultTreeModel) getJtreDocumento().getModel();
                      if (parent != null) {
                          model.removeNodeFromParent(insertNode);
                      }
                  }
                  i++;
              }
          }
          LeeArbol();
      }//GEN-LAST:event_jmniEliminarActionPerformed

      /**
       * jmniEditarActionPerformed Activa el menu item editar
       * @param evt
       */
      private void jmniEditarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jmniEditarActionPerformed
          TreePath tp = jtreDocumento.getSelectionPath();
          MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
          String Nombre = insertNode.toString();

          if (Nombre.startsWith("CU")) {
              List<CasodeUso> casoU = docPpal.getCasodeUso();
              int i = 0;
              boolean encontrado = false;
              while (i < casoU.size() && encontrado == false) {
                  if (casoU.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmCasodeUso jfCU = new jfrmCasodeUso(this, docPpal, insertNode, insertIndex);
                      jfCU.editarPropiedades(casoU.get(i));
                      jfCU.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jfCU);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("PCU")) {
              MutableTreeNode auxinsertNode = (MutableTreeNode) tp.getLastPathComponent();
              auxinsertNode = (MutableTreeNode) auxinsertNode.getParent();
              String NomC = auxinsertNode.toString();
              for (int j = 0; j < docPpal.getCasodeUso().size(); j++) {
                  if (docPpal.getCasodeUso().get(j).getIdent().equals(NomC)) {
                      CU = docPpal.getCasodeUso().get(j);
                  }
              }
              List<PasoCU> Paso = CU.getPasoCU();
              int i = 0;
              boolean encontrado = false;
              while (i < Paso.size() && encontrado == false) {
                  if (Paso.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmPaso jfPs = new jfrmPaso(this, docPpal, insertNode, insertIndex, CU);
                      jfPs.editarPropiedades(Paso.get(i));
                      jfPs.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jfPs);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("EXCU")) {
              MutableTreeNode auxinsertNode1 = (MutableTreeNode) tp.getLastPathComponent();
              auxinsertNode1 = (MutableTreeNode) auxinsertNode1.getParent();
              String NomC1 = auxinsertNode1.toString();
              for (int j = 0; j < docPpal.getCasodeUso().size(); j++) {
                  for (int m = 0; m < docPpal.getCasodeUso().get(j).getPasoCU().size(); m++) {
                      if (docPpal.getCasodeUso().get(j).getPasoCU().get(m).getIdent().equals(NomC1)) {
                          CU = docPpal.getCasodeUso().get(j);
                          PS = docPpal.getCasodeUso().get(j).getPasoCU().get(m);
                          auxps = m;
                      }
                  }
              }
              List<ExcepcionCU> ECU = PS.getExcepcionCU();
              int i = 0;
              boolean encontrado = false;
              while (i < ECU.size() && encontrado == false) {
                  if (ECU.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmExcepcionCU jfECU = new jfrmExcepcionCU(this, docPpal, insertNode, insertIndex, CU, PS, auxps);
                      jfECU.editarPropiedades(ECU.get(i));
                      jfECU.setVisible(true);
                      this.setEnabled(false);
                      PS.addObserver(jfECU);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("RR")) {
              ArrayList<RequisitoRestriccion> ReqRes = docPpal.getRequisitoRestriccion();
              int i = 0;
              boolean encontrado = false;
              while (i < ReqRes.size() && encontrado == false) {
                  if (ReqRes.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmReqRestriccion jfRR = new jfrmReqRestriccion(this, docPpal, insertNode, insertIndex);
                      jfRR.editarPropiedades(ReqRes.get(i));
                      jfRR.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jfRR);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("RI")) {
              ArrayList<RequisitoInformacion> ReqInf = docPpal.getRequisitoInformacion();
              int i = 0;
              boolean encontrado = false;
              while (i < ReqInf.size() && encontrado == false) {
                  if (ReqInf.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmReqInformacion jfRI = new jfrmReqInformacion(this, docPpal, insertNode, insertIndex);
                      jfRI.editarPropiedades(ReqInf.get(i));
                      jfRI.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jfRI);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("DAT")) {
              MutableTreeNode auxinsertNode2 = (MutableTreeNode) tp.getLastPathComponent();
              auxinsertNode2 = (MutableTreeNode) auxinsertNode2.getParent();
              String NomC2 = auxinsertNode2.toString();
              for (int j = 0; j < docPpal.getRequisitoInformacion().size(); j++) {
                  if (docPpal.getRequisitoInformacion().get(j).getIdent().equals(NomC2)) {
                      RI = docPpal.getRequisitoInformacion().get(j);
                  }
              }
              ArrayList<DatoEspecifico> DE = RI.getDatoEspecifico();
              int i = 0;
              boolean encontrado = false;
              while (i < DE.size() && encontrado == false) {
                  if (DE.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmDatoEspecifico jfDa = new jfrmDatoEspecifico(this, docPpal, insertNode, insertIndex, RI);
                      jfDa.editarPropiedades(DE.get(i));
                      jfDa.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jfDa);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("RF")) {
              ArrayList<RequisitoFuncional> ReqFun = docPpal.getRequisitoFuncional();
              int i = 0;
              boolean encontrado = false;
              while (i < ReqFun.size() && encontrado == false) {
                  if (ReqFun.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmReqFuncional jfRF = new jfrmReqFuncional(this, docPpal, insertNode, insertIndex);
                      jfRF.editarPropiedades(ReqFun.get(i));
                      jfRF.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jfRF);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("RNF")) {
              ArrayList<RequisitoNoFuncional> RNF = docPpal.getRequisitoNoFuncional();
              int i = 0;
              boolean encontrado = false;
              while (i < RNF.size() && encontrado == false) {
                  if (RNF.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmReqNoFuncional jfRNF = new jfrmReqNoFuncional(this, docPpal, insertNode, insertIndex);
                      jfRNF.editarPropiedades(RNF.get(i));
                      jfRNF.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jfRNF);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("ACT")) {
              ArrayList<Actor> Ac = docPpal.getActor();
              int i = 0;
              boolean encontrado = false;
              while (i < Ac.size() && encontrado == false) {
                  if (Ac.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmActor jfAc = new jfrmActor(this, docPpal, insertNode, insertIndex);
                      jfAc.editarPropiedades(Ac.get(i));
                      jfAc.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jfAc);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("OB")) {
              ArrayList<Objetivo> ob = docPpal.getObjetivo();
              int i = 0;
              boolean encontrado = false;
              while (i < ob.size() && encontrado == false) {
                  if (ob.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmObjetivo jfOb = new jfrmObjetivo(this, docPpal, insertNode, insertIndex);
                      jfOb.editarPropiedades(ob.get(i));
                      jfOb.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jfOb);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("SUBO")) {
              MutableTreeNode auxinsertNode3 = (MutableTreeNode) tp.getLastPathComponent();
              auxinsertNode3 = (MutableTreeNode) auxinsertNode3.getParent();
              String NomC3 = auxinsertNode3.toString();
              for (int j = 0; j < docPpal.getObjetivo().size(); j++) {
                  if (docPpal.getObjetivo().get(j).getIdent().equals(NomC3)) {
                      Ob = docPpal.getObjetivo().get(j);
                  }
              }
              ArrayList<Subobjetivo> subobj = Ob.getSubobjetivo();
              int i = 0;
              boolean encontrado = false;
              while (i < subobj.size() && encontrado == false) {
                  if (subobj.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmSubobjetivo jfSO = new jfrmSubobjetivo(this, docPpal, insertNode, insertIndex,Ob);
                      jfSO.editarPropiedades(subobj.get(i));
                      jfSO.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jfSO);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("PART")) {
              ArrayList<Participante> part = docPpal.getParticipante();
              int i = 0;
              boolean encontrado = false;
              while (i < part.size() && encontrado == false) {
                  if (part.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmParticipante jfPart = new jfrmParticipante(this, docPpal, insertNode, insertIndex);
                      jfPart.editarPropiedades(part.get(i));
                      jfPart.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jfPart);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("REU")) {
              ArrayList<Reunion> reu = docPpal.getReunion();
              int i = 0;
              boolean encontrado = false;
              while (i < reu.size() && encontrado == false) {
                  if (reu.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmReunion jfReu = new jfrmReunion(this, docPpal, insertNode, insertIndex);
                      jfReu.editarPropiedades(reu.get(i));
                      jfReu.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jfReu);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("PARR")) {
              ArrayList<Parrafo> parr = docPpal.getParrafo();
              int i = 0;
              boolean encontrado = false;
              while (i < parr.size() && encontrado == false) {
                  if (parr.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmParrafo jfParr = new jfrmParrafo(this, docPpal, insertNode, insertIndex);
                      jfParr.editarPropiedades(parr.get(i));
                      jfParr.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jfParr);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("FICH")) {
              ArrayList<FicheroGrafico> fiche = docPpal.getFicheroGrafico();
              int i = 0;
              boolean encontrado = false;
              while (i < fiche.size() && encontrado == false) {
                  if (fiche.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmFicheroGrafico jfFg = new jfrmFicheroGrafico(this, docPpal, insertNode, insertIndex);
                      jfFg.editarPropiedades(fiche.get(i));
                      jfFg.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jfFg);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("MAT")) {
              ArrayList<MatrizRastreabilidad> maR = docPpal.getMatrizRastreabilidad();
              int i = 0;
              boolean encontrado = false;
              while (i < maR.size() && encontrado == false) {
                  if (maR.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmMatrizRastreabilidad jfMR = new jfrmMatrizRastreabilidad(this, docPpal, insertNode, insertIndex);
                      jfMR.editarPropiedades(maR.get(i));
                      jfMR.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jfMR);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("SECC")) {
              ArrayList<Seccion> secc = docPpal.getSeccion();
              int i = 0;
              boolean encontrado = false;
              while (i < secc.size() && encontrado == false) {
                  if (secc.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmSeccion jfse = new jfrmSeccion(this, docPpal, insertNode, insertIndex);
                      jfse.editarPropiedades(secc.get(i));
                      jfse.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jfse);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("ORG")) {
              ArrayList<Organizacion> org = docPpal.getOrganizacion();
              int i = 0;
              boolean encontrado = false;
              while (i < org.size() && encontrado == false) {
                  if (org.get(i).getIdent().equals(Nombre)) {
                      encontrado = true;
                      insertNode = (MutableTreeNode) tp.getLastPathComponent();
                      int insertIndex = 0;
                      if (insertNode.getParent() != null) {
                          MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                          insertIndex = parent.getIndex(insertNode) + 1;
                          insertNode = parent;
                      }
                      jfrmOrganizacion jforg = new jfrmOrganizacion(this, docPpal, insertNode, insertIndex);
                      jforg.editarPropiedades(org.get(i));
                      jforg.setVisible(true);
                      this.setEnabled(false);
                      docPpal.addObserver(jforg);
                  }
                  i++;
              }
          }
          if (Nombre.startsWith("Do")) {
              jfrmDocumentoReq jfdoc = new jfrmDocumentoReq(this, auxGD, docPpal);
              jfdoc.editarPropiedades(docPpal);
              jfdoc.setVisible(true);
              this.setEnabled(false);
          }
          LeeArbol();
      }//GEN-LAST:event_jmniEditarActionPerformed

      /**
       * jbtnFicheroGraficoActionPerformed Activa el boton fichero grafico
       * @param evt
       */
      private void jbtnFicheroGraficoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnFicheroGraficoActionPerformed
         TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione el documento de requisitos");
          } else {
              String NomC;
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              NomC = insertNode.toString();
              if (!NomC.startsWith("Do")) {
                  jlblMensaje.setText("Seleccione el documento de requisitos");
              } else {
                  int insertIndex = 0;
                  jfrmFicheroGrafico jfFich = new jfrmFicheroGrafico(this, docPpal, insertNode, insertIndex);
                  jfFich.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfFich);
              }
          }
}//GEN-LAST:event_jbtnFicheroGraficoActionPerformed

      /**
       * jbtnSeccionActionPerformed Activa el boton seccion
       * @param evt
       */
      private void jbtnSeccionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnSeccionActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione el documento de requisitos");
          } else {
              String NomC;
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              NomC = insertNode.toString();
              if (!NomC.startsWith("Do")) {
                  jlblMensaje.setText("Seleccione el documento de requisitos");
              } else {
                  int insertIndex = 0;
                  if (insertNode.getParent() != null) {
                      MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                      insertIndex = parent.getIndex(insertNode) + 1;
                      insertNode = parent;
                  }
                  jfrmSeccion jSe = new jfrmSeccion(this, docPpal, insertNode, insertIndex);
                  jSe.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jSe);
              }
          }
}//GEN-LAST:event_jbtnSeccionActionPerformed

      /**
       * jbtnOrganizacionActionPerformed Activa el boton organizacion
       * @param evt
       */
      private void jbtnOrganizacionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnOrganizacionActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione el documento de requisitos");
          } else {
              String NomC;
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              NomC = insertNode.toString();
              if (!NomC.startsWith("Do")) {
                  jlblMensaje.setText("Seleccione el documento de requisitos");
              } else {
                  int insertIndex = 0;
                  if (insertNode.getParent() != null) {
                      MutableTreeNode parent = (MutableTreeNode) insertNode.getParent();
                      insertIndex = parent.getIndex(insertNode) + 1;
                      insertNode = parent;
                  }
                  jfrmOrganizacion jOrg = new jfrmOrganizacion(this, docPpal, insertNode, insertIndex);
                  jOrg.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jOrg);
              }
          }
}//GEN-LAST:event_jbtnOrganizacionActionPerformed

      /**
       * jmniGuardarHTMLActionPerformed Activa el menu item guardar HTML
       * @param evt
       */
      private void jmniGuardarHTMLActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jmniGuardarHTMLActionPerformed
          try {
              JFileChooser fc = new JFileChooser(System.getProperty("user.dir"));
              fc.addChoosableFileFilter(filtroHtml);
              fc.showSaveDialog(this); //Muestra el diálogo
              File Guardar = fc.getSelectedFile();
              if (Guardar != null) {
                  FileWriter Guardx = new FileWriter(Guardar);
                  Guardx.write(resultado);
                  Guardx.close(); //Cierra el fichero
              }
          } catch (IOException ioe) {
              System.out.println(ioe); //Muestra por consola los errores}
          }
      }//GEN-LAST:event_jmniGuardarHTMLActionPerformed

      /**
       * jmniLeeArbolActionPerformed Activa el menu item leer arbol
       * @param evt
       */
      private void jmniLeeArbolActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jmniLeeArbolActionPerformed
          try {
              docPpal.toXML();
              resultado = transformar();
              jtxpDocumento.setText(resultado.toString());
          } catch (Exception e) {
              Logger.getLogger(jfrmPrincipal.class.getName()).log(Level.SEVERE, null, e);
          }
}//GEN-LAST:event_jmniLeeArbolActionPerformed

      /**
       * jmniXSLActionPerformed Activa el menu item XSL
       * @param evt
       */
      private void jmniXSLActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jmniXSLActionPerformed
          jfrmXSL jfX = new jfrmXSL(this);
          jfX.setVisible(true);
          this.setEnabled(false);
}//GEN-LAST:event_jmniXSLActionPerformed

      /**
       * jmniNuevoActionPerformed Activa el menu item nuevo
       * @param evt
       */
      private void jmniNuevoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jmniNuevoActionPerformed
      }//GEN-LAST:event_jmniNuevoActionPerformed

      /**
       * jmniAbrirActionPerformed Activa el menu item abrir
       * @param evt
       */
      private void jmniAbrirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jmniAbrirActionPerformed
          try {
              JFileChooser fc = new JFileChooser(System.getProperty("user.dir"));
              fc.addChoosableFileFilter(filtro);
              fc.showOpenDialog(this); //Muestra el diálogo
              File Abrir = fc.getSelectedFile();
              if (Abrir != null) {
                  FileInputStream Abrirx = new FileInputStream(Abrir);
                  ObjectInputStream ois = new ObjectInputStream(Abrirx);
                  DocumentoReq obj1 = (DocumentoReq) ois.readObject();
                  docPpal = obj1;
                  DefaultTreeModel loadedTreeModel = (DefaultTreeModel) ois.readObject();
                  jtreDocumento.setModel(loadedTreeModel);
                  LeeArbol();
                  System.out.println("Abierto correctamente");
                  ois.close();//Cierra el fichero
              }
          } catch (ClassNotFoundException ex) {
              Logger.getLogger(jfrmPrincipal.class.getName()).log(Level.SEVERE, null, ex);
          } catch (IOException ioe) {
              System.out.println(ioe); //Muestra por consola los errores}
          }
      }//GEN-LAST:event_jmniAbrirActionPerformed

      /**
       * jmniGuardarActionPerformed Activa el menu item guardar
       * @param evt
       */
      private void jmniGuardarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jmniGuardarActionPerformed
          try {
              JFileChooser fc = new JFileChooser(System.getProperty("user.dir"));
              fc.addChoosableFileFilter(filtro);
              fc.showSaveDialog(this); //Muestra el diálogo
              File Guardar = fc.getSelectedFile();
              if (Guardar != null) {
                  FileOutputStream Guardx = new FileOutputStream(Guardar);
                  ObjectOutputStream oos = new ObjectOutputStream(Guardx);
                  oos.writeObject(docPpal);
                  DefaultMutableTreeNode root = ((DefaultMutableTreeNode) jtreDocumento.getModel().getRoot());
                  ((DefaultTreeModel) jtreDocumento.getModel()).reload();
                  oos.writeObject((DefaultTreeModel) jtreDocumento.getModel());
                  oos.flush();
                  oos.close();//Cierra el fichero
                  System.out.println("Guardado correctamente");
              }
          } catch (IOException ioe) {
              System.out.println(ioe); //Muestra por consola los errores}
          }
      }//GEN-LAST:event_jmniGuardarActionPerformed

      /**
       * jmniSUBOActionPerformed Activa el menu item subobjetivo
       * @param evt
       */
      private void jmniSUBOActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jmniSUBOActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione un documento de requisitos");
          } else {
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              String NomC = insertNode.toString();

              if (!NomC.startsWith("OB")) {
                  jlblMensaje.setText("Seleccione un objetivo");
              } else {
                  int insertIndex = 0;
                  jfrmSubobjetivo jfSubo = new jfrmSubobjetivo(this, docPpal, insertNode, insertIndex, Ob);

                  jfSubo.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfSubo);
              }
          }
      }//GEN-LAST:event_jmniSUBOActionPerformed

      /**
       * jmniDEActionPerformed Activa el menu item dato especifico
       * @param evt
       */
      private void jmniDEActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jmniDEActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione un documento de requisitos");
          } else {
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              String NomC = insertNode.toString();

              if (!NomC.startsWith("RI")) {
                  jlblMensaje.setText("Seleccione un requisito de informacion");
              } else {
                  int insertIndex = 0;
                  jfrmDatoEspecifico jfDE = new jfrmDatoEspecifico(this, docPpal, insertNode, insertIndex, RI);

                  jfDE.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfDE);
              }
          }
      }//GEN-LAST:event_jmniDEActionPerformed

      /**
       * jmniExcepcion1ActionPerformed Activa el menu item excepcion
       * @param evt
       */
      private void jmniExcepcion1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jmniExcepcion1ActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione un documento de requisitos");
          } else {
              String NomC;
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              NomC = insertNode.toString();
              if (!NomC.startsWith("PCU")) {
                  jlblMensaje.setText("Seleccione un paso");
              } else {
                  int insertIndex = 0;
                  for (int i = 0; i < docPpal.getCasodeUso().size(); i++) {
                      for (int j = 0; j < docPpal.getCasodeUso().get(i).getPasoCU().size(); j++) {
                          if (docPpal.getCasodeUso().get(i).getPasoCU().get(j).getIdent().equals(NomC)) {
                              CU = docPpal.getCasodeUso().get(i);
                              PS = docPpal.getCasodeUso().get(i).getPasoCU().get(j);
                              auxps = j;
                          }
                      }
                  }
                  jfrmExcepcionCU jfexpCU = new jfrmExcepcionCU(this, docPpal, insertNode, insertIndex, CU, PS, auxps);
                  jfexpCU.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfexpCU);
              }
          }
      }//GEN-LAST:event_jmniExcepcion1ActionPerformed

      /**
       * jmniPaso1ActionPerformed Activa el menu item paso
       * @param evt
       */
      private void jmniPaso1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jmniPaso1ActionPerformed
          TreePath tp = getJtreDocumento().getSelectionPath();
          if (tp == null) {
              jlblMensaje.setText("Seleccione un documento de requisitos");
          } else {
              MutableTreeNode insertNode = (MutableTreeNode) tp.getLastPathComponent();
              String NomC = insertNode.toString();
              if (!NomC.startsWith("CU")) {
                  jlblMensaje.setText("Seleccione un Caso de Uso");
              } else {
                  boolean encontrado = false;
                  int insertIndex = 0;
                  for (int i = 0; i < docPpal.getCasodeUso().size(); i++) {
                      if (docPpal.getCasodeUso().get(i).getIdent().equals(NomC)) {
                          encontrado = true;
                          CU = docPpal.getCasodeUso().get(i);
                      }
                  }
                  jfrmPaso jfPaso = new jfrmPaso(this, docPpal, insertNode, insertIndex, CU);

                  jfPaso.setVisible(true);
                  this.setEnabled(false);
                  jlblMensaje.setText("");
                  docPpal.addObserver(jfPaso);
              }
          }
      }//GEN-LAST:event_jmniPaso1ActionPerformed

      /**
       * formWindowClosing es el metodo al que se llama cuando se esta cerrando
       * para mostrar un mensaje
       * @param evt
       */
      private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
          mostrarMensaje("Desea guardar el documento");
          this.setEnabled(true);
      }//GEN-LAST:event_formWindowClosing

    /**
     * boton_derecho es el metodo al que se le pasa la opcion para colocar el menu
     * correspondiente a cada elemento
     * @param i
     */
    public void boton_derecho(int i) {
        if (i == -1){
            jppupMenu.removeAll();
            jppupMenu.add(jmniEditar);
        }else{
            if (i == 0) {
                jppupMenu.removeAll();
                jppupMenu.add(jmniPaso1);
                jppupMenu.add(jmniEditar);
                jppupMenu.add(jmniEliminar);
            } else {
                if (i == 1) {
                    jppupMenu.removeAll();
                    jppupMenu.add(jmniExcepcion1);
                    jppupMenu.add(jmniEditar);
                    jppupMenu.add(jmniEliminar);
                } else {
                    if (i == 2) {
                        jppupMenu.removeAll();
                        jppupMenu.add(jmniSUBO);
                        jppupMenu.add(jmniEditar);
                        jppupMenu.add(jmniEliminar);
                    } else {
                        if (i == 3) {
                            jppupMenu.removeAll();
                            jppupMenu.add(jmniDE);
                            jppupMenu.add(jmniEditar);
                            jppupMenu.add(jmniEliminar);
                        } else {
                            jppupMenu.removeAll();
                            jppupMenu.add(jmniEditar);
                            jppupMenu.add(jmniEliminar);
                        }
                    }
                }
            }
        }
        if(i == -2){
            jppupMenu.removeAll();
        }
    }
    /**
     * @param args the command line arguments
     */
    /*public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
    public void run() {
    new jfrmPrincipal().setVisible(true);
    }
    });
    }*/

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JInternalFrame jInternalFrame1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JToolBar.Separator jSeparator1;
    private javax.swing.JToolBar.Separator jSeparator2;
    private javax.swing.JToolBar.Separator jSeparator3;
    private javax.swing.JToolBar.Separator jSeparator4;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JButton jbtnActor;
    private javax.swing.JButton jbtnDatoEspecifico;
    private javax.swing.JButton jbtnFicheroGrafico;
    private javax.swing.JButton jbtnMatrizRastreabilidad;
    private javax.swing.JButton jbtnObjetivo;
    private javax.swing.JButton jbtnOrganizacion;
    private javax.swing.JButton jbtnParrafo;
    private javax.swing.JButton jbtnParticipante;
    private javax.swing.JButton jbtnReqFuncional;
    private javax.swing.JButton jbtnReqInformacion;
    private javax.swing.JButton jbtnReqNoFuncional;
    private javax.swing.JButton jbtnReqRestriccion;
    private javax.swing.JButton jbtnReunion;
    private javax.swing.JButton jbtnSeccion;
    private javax.swing.JButton jbtnSubobjetivo;
    private javax.swing.JLabel jlblMensaje;
    private javax.swing.JMenuItem jmniAbrir;
    private javax.swing.JMenuItem jmniDE;
    private javax.swing.JMenuItem jmniEditar;
    private javax.swing.JMenuItem jmniEliminar;
    private javax.swing.JMenuItem jmniExcepcion;
    private javax.swing.JMenuItem jmniExcepcion1;
    private javax.swing.JMenuItem jmniGuardar;
    private javax.swing.JMenuItem jmniGuardarHTML;
    private javax.swing.JMenuItem jmniLeeArbol;
    public javax.swing.JMenuItem jmniNuevo;
    private javax.swing.JMenuItem jmniNuevoCU;
    private javax.swing.JMenuItem jmniPaso;
    private javax.swing.JMenuItem jmniPaso1;
    private javax.swing.JMenuItem jmniSUBO;
    private javax.swing.JMenuItem jmniSalir;
    private javax.swing.JMenuItem jmniXSL;
    private javax.swing.JMenu jmnuArchivo;
    private javax.swing.JMenuBar jmnuBarraPpal;
    private javax.swing.JMenu jmnuCU;
    private javax.swing.JMenu jmnuHerramientas;
    private javax.swing.JMenu jmnuSalir;
    private javax.swing.JPopupMenu jppupMenu;
    private javax.swing.JTree jtreDocumento;
    private javax.swing.JTextPane jtxpDocumento;
    // End of variables declaration//GEN-END:variables

    /**
     * getJtreDocumento metodo para devolver el jtree
     * @return the jtreDocumento
     */
    public javax.swing.JTree getJtreDocumento() {
        return jtreDocumento;
    }

    /**
     * setJtreDocumento metodo para insertar el jtree
     * @param jtreDocumento the jtreDocumento to set
     */
    public void setJtreDocumento(javax.swing.JTree jtreDocumento) {
        this.jtreDocumento = jtreDocumento;
    }

    /**
     * Muestra un mensaje en un JOptionPane y te da la opcion de elegir si guardar o no.
     * @param mensaje a mostrar en el JOptionPane
     */
    protected void mostrarMensaje(String mensaje) {
        int yes = JOptionPane.showConfirmDialog(this, mensaje, "Advertencia", JOptionPane.YES_NO_OPTION);
        if (yes == JOptionPane.YES_OPTION){
            this.jmniGuardarActionPerformed(evt);
            this.setEnabled(true);
            this.dispose();
            System.exit(0);
        }
        if (yes == JOptionPane.NO_OPTION) {
            System.exit(0);
        }
        if (yes == JOptionPane.CLOSED_OPTION) {
            System.exit(0);
        }
    }

    public void update(Observable o, Object arg) {
    }

    /**
     * setEstilo devuelve el estilo que vamos a poner en el jtxpDocumento
     * @param estiloPredet the estiloPredet to set
     */
    public void setEstilo(boolean estiloPredet) {
        this.estiloPredet = estiloPredet;
    }
}
