/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * jfrmReqRestriccion.java
 *
 * Created on 13-dic-2011, 23:22:19
 */

package vista;

import java.util.ArrayList;
import java.util.Observable;
import java.util.Observer;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import modelo.DocumentoReq;
import modelo.RequisitoInformacion;

/**
 * jfrmReqInformacion es el formulario con el cual podremos insertar todas las variables del requisito de informacion
 */
public class jfrmReqInformacion extends javax.swing.JFrame implements Observer {
    DocumentoReq auxDocPpal;
    jfrmPrincipal jfaux;
    RequisitoInformacion newRI, auxRI;
    MutableTreeNode auxinsertNode;
    int auxinsertIndex;
    private boolean editar=false;
    MutableTreeNode parent;
    int insertIndex2;
    ArrayList <String> auxLD = new ArrayList();
    ArrayList <String> auxLO = new ArrayList();

    /**
     * Constructor de JFrame ReqInformacion
     * @param jf es el formulario principal
     * @param docPpal es el documento donde se guardan todas las variables
     * @param insertNode el nodo a insertar
     * @param insertIndex el indice del nodo a insertar
     */
    public jfrmReqInformacion(jfrmPrincipal jf,DocumentoReq docPpal, MutableTreeNode insertNode, int insertIndex) {
        auxinsertNode=insertNode;
        auxinsertIndex=insertIndex;
        jfaux=jf;
        auxDocPpal=docPpal;
        this.setIconImage(new ImageIcon("src/imagenes/informacion.jpg").getImage());
        initComponents();
        int l = 0, i=0;
        int cont = auxDocPpal.getLIdentRI().size();
        i = auxDocPpal.getRequisitoInformacion().size();
        if (i == cont) {
            i = i + 1;
        } else {
            for (l = 0; l < cont; l++) {
                if (auxDocPpal.getLIdentRI().get(l) == 0) {
                    i = l + 1;
                }
            }
        }
        String ident;
        ident ="RI"+String.valueOf(i);
        jtxtId.setText(ident);
    }

    /**
     * editarPropiedades Método que edita las propiedades de un requisito de informacion
     * @param RI requisito de informacion para editar
     */
    void editarPropiedades(RequisitoInformacion RI) {
        editar = true;
        jtxtId.setText(RI.getIdent());
        DefaultListModel listModel = new DefaultListModel();
        DefaultListModel listModel2 = new DefaultListModel();
        jtxtNombre.setText(RI.getNombre());
        jtxaConcepto.setText(RI.getConcepto());
        jtxtUnMax.setText(RI.getUnidadTMax());
        jtxtUnMe.setText(RI.getUnidadTMe());
        jtxtValorMax.setText(String.valueOf(RI.getValorMax()));
        jtxtValorMe.setText(String.valueOf(RI.getValorMe()));
        jtxtNumMax.setText(String.valueOf(RI.getNumeroMax()));
        jtxtNumMe.setText(String.valueOf(RI.getNumeroMe()));
        jcbImportancia.setSelectedItem(RI.getImportancia());
        jcbUrgencia.setSelectedItem(RI.getUrgencia());
        jcbEstado.setSelectedItem(RI.getEstado());
        jcbEstabilidad.setSelectedItem(RI.getEstabilidad());
        if (RI.getMDestino().size() != 0) {
            jlstTDestino.setModel(listModel);
            for (int i = 0; i < RI.getMDestino().size(); i++) {
                listModel.add(i, RI.getMDestino().get(i));
            }

        }
        if (RI.getMOrigen().size() != 0) {
            jlstTOrigen.setModel(listModel2);
            for (int i = 0; i < RI.getMOrigen().size(); i++) {
                listModel2.add(i, RI.getMOrigen().get(i));
            }
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabReqInformacion = new javax.swing.JTabbedPane();
        jpanGeneral = new javax.swing.JPanel();
        jlbConcepto = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jtxaConcepto = new javax.swing.JTextArea();
        jlbTiempoMaximo = new javax.swing.JLabel();
        jlbValor = new javax.swing.JLabel();
        jlbUnidadTiempo = new javax.swing.JLabel();
        jtxtValorMax = new javax.swing.JTextField();
        jtxtUnMax = new javax.swing.JTextField();
        jlbTiempoMedio = new javax.swing.JLabel();
        jtxtValorMe = new javax.swing.JTextField();
        jlbVal = new javax.swing.JLabel();
        jlbUnTiempo = new javax.swing.JLabel();
        jtxtUnMe = new javax.swing.JTextField();
        jlbOcurrencias = new javax.swing.JLabel();
        jlbNumMax = new javax.swing.JLabel();
        jlbNumMedio = new javax.swing.JLabel();
        jtxtNumMax = new javax.swing.JTextField();
        jtxtNumMe = new javax.swing.JTextField();
        jlbNombre = new javax.swing.JLabel();
        jtxtNombre = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        jtxtId = new javax.swing.JTextField();
        jpanPrioridad = new javax.swing.JPanel();
        jlbImportancia = new javax.swing.JLabel();
        jlbUrgencia = new javax.swing.JLabel();
        jlbEstDesarrollo = new javax.swing.JLabel();
        jlbEstabilidad = new javax.swing.JLabel();
        jcbImportancia = new javax.swing.JComboBox();
        jcbUrgencia = new javax.swing.JComboBox();
        jcbEstado = new javax.swing.JComboBox();
        jcbEstabilidad = new javax.swing.JComboBox();
        jPanel1 = new javax.swing.JPanel();
        jbtnInsertarTDestino = new javax.swing.JButton();
        jbtnInsertarTOrigen = new javax.swing.JButton();
        jScrollPane5 = new javax.swing.JScrollPane();
        jlstTOrigen = new javax.swing.JList();
        jLabel13 = new javax.swing.JLabel();
        jScrollPane4 = new javax.swing.JScrollPane();
        jlstTDestino = new javax.swing.JList();
        jLabel12 = new javax.swing.JLabel();
        jbtnAceptar = new javax.swing.JButton();
        jbtnCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Requisito de Información");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jlbConcepto.setText("Concepto relevante");

        jtxaConcepto.setColumns(20);
        jtxaConcepto.setRows(5);
        jtxaConcepto.setText("PD");
        jScrollPane2.setViewportView(jtxaConcepto);

        jlbTiempoMaximo.setText("Tiempo máximo de vida");

        jlbValor.setText("Valor");

        jlbUnidadTiempo.setText("Unidad de tiempo");

        jtxtValorMax.setText("0");

        jtxtUnMax.setText("PD");

        jlbTiempoMedio.setText("Tiempo medio de vida");

        jtxtValorMe.setText("0");

        jlbVal.setText("Valor");

        jlbUnTiempo.setText("Unidad de tiempo");

        jlbOcurrencias.setText("Ocurrencias simultáneas");

        jlbNumMax.setText("Número máximo");

        jlbNumMedio.setText("Número medio");

        jtxtNumMax.setText("0");

        jtxtNumMe.setText("0");

        jlbNombre.setText("Nombre");

        jLabel14.setText("Identificador:");

        jtxtId.setEditable(false);

        javax.swing.GroupLayout jpanGeneralLayout = new javax.swing.GroupLayout(jpanGeneral);
        jpanGeneral.setLayout(jpanGeneralLayout);
        jpanGeneralLayout.setHorizontalGroup(
            jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanGeneralLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jlbNumMax)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jtxtNumMax, javax.swing.GroupLayout.PREFERRED_SIZE, 68, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jlbNumMedio)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jtxtNumMe, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(89, 89, 89))
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jlbOcurrencias)
                        .addContainerGap(278, Short.MAX_VALUE))
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jlbVal)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jtxtValorMe, javax.swing.GroupLayout.PREFERRED_SIZE, 55, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(38, 38, 38)
                        .addComponent(jlbUnTiempo)
                        .addGap(18, 18, 18)
                        .addComponent(jtxtUnMe, javax.swing.GroupLayout.DEFAULT_SIZE, 123, Short.MAX_VALUE)
                        .addGap(43, 43, 43))
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jlbTiempoMedio)
                        .addContainerGap(291, Short.MAX_VALUE))
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jpanGeneralLayout.createSequentialGroup()
                                .addGap(127, 127, 127)
                                .addComponent(jlbUnidadTiempo)
                                .addGap(18, 18, 18)
                                .addComponent(jtxtUnMax, javax.swing.GroupLayout.DEFAULT_SIZE, 123, Short.MAX_VALUE))
                            .addGroup(jpanGeneralLayout.createSequentialGroup()
                                .addComponent(jlbValor)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jtxtValorMax, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 264, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(43, 43, 43))
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jlbTiempoMaximo)
                        .addContainerGap(283, Short.MAX_VALUE))
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 380, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jlbConcepto)
                            .addGroup(jpanGeneralLayout.createSequentialGroup()
                                .addComponent(jlbNombre)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jtxtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addContainerGap(14, Short.MAX_VALUE))
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jLabel14, javax.swing.GroupLayout.DEFAULT_SIZE, 65, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jtxtId, javax.swing.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE)
                        .addGap(227, 227, 227))))
        );
        jpanGeneralLayout.setVerticalGroup(
            jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanGeneralLayout.createSequentialGroup()
                .addGap(14, 14, 14)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtxtId)
                    .addComponent(jLabel14, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlbNombre)
                    .addComponent(jtxtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jlbConcepto)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jlbTiempoMaximo)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlbValor)
                    .addComponent(jtxtValorMax, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jlbUnidadTiempo)
                    .addComponent(jtxtUnMax, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jlbTiempoMedio)
                .addGap(4, 4, 4)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlbVal)
                    .addComponent(jtxtValorMe, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jlbUnTiempo)
                    .addComponent(jtxtUnMe, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jlbOcurrencias)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlbNumMax)
                    .addComponent(jlbNumMedio)
                    .addComponent(jtxtNumMax, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jtxtNumMe, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        jTabReqInformacion.addTab("General", jpanGeneral);

        jlbImportancia.setText("Importancia");

        jlbUrgencia.setText("Urgencia");

        jlbEstDesarrollo.setText("Estado de desarrollo");

        jlbEstabilidad.setText("Estabilidad");

        jcbImportancia.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PD", "vital", "importante" }));

        jcbUrgencia.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PD", "inmediata", "hay presión" }));

        jcbEstado.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PD", "en construcción", "pendiente de verificación" }));

        jcbEstabilidad.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PD", "baja ", "media", "alta" }));

        javax.swing.GroupLayout jpanPrioridadLayout = new javax.swing.GroupLayout(jpanPrioridad);
        jpanPrioridad.setLayout(jpanPrioridadLayout);
        jpanPrioridadLayout.setHorizontalGroup(
            jpanPrioridadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanPrioridadLayout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(jpanPrioridadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jlbEstabilidad)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jpanPrioridadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addComponent(jcbEstabilidad, javax.swing.GroupLayout.Alignment.LEADING, 0, 374, Short.MAX_VALUE)
                        .addComponent(jcbImportancia, javax.swing.GroupLayout.Alignment.LEADING, 0, 374, Short.MAX_VALUE)
                        .addComponent(jlbImportancia, javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(jlbUrgencia, javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(jcbUrgencia, javax.swing.GroupLayout.Alignment.LEADING, 0, 374, Short.MAX_VALUE)
                        .addComponent(jlbEstDesarrollo, javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(jcbEstado, javax.swing.GroupLayout.Alignment.LEADING, 0, 374, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jpanPrioridadLayout.setVerticalGroup(
            jpanPrioridadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanPrioridadLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jlbImportancia)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jcbImportancia, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jlbUrgencia)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jcbUrgencia, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jlbEstDesarrollo)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jcbEstado, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jlbEstabilidad)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jcbEstabilidad)
                .addGap(63, 63, 63))
        );

        jTabReqInformacion.addTab("Prioridad", jpanPrioridad);

        jbtnInsertarTDestino.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/insertTD.jpg"))); // NOI18N
        jbtnInsertarTDestino.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnInsertarTDestinoActionPerformed(evt);
            }
        });

        jbtnInsertarTOrigen.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/insertTO.jpg"))); // NOI18N
        jbtnInsertarTOrigen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnInsertarTOrigenActionPerformed(evt);
            }
        });

        jScrollPane5.setViewportView(jlstTOrigen);

        jLabel13.setText("Trazas Origen");

        jScrollPane4.setViewportView(jlstTDestino);

        jLabel12.setText("Trazas Destino");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGap(2, 2, 2)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(11, 11, 11)
                        .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 291, Short.MAX_VALUE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, 98, Short.MAX_VALUE)
                        .addGap(204, 204, 204))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel13, javax.swing.GroupLayout.DEFAULT_SIZE, 94, Short.MAX_VALUE)
                        .addGap(208, 208, 208))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 292, Short.MAX_VALUE)))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jbtnInsertarTDestino, 0, 0, Short.MAX_VALUE)
                    .addComponent(jbtnInsertarTOrigen, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(44, 44, 44))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, 19, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 88, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel13, javax.swing.GroupLayout.DEFAULT_SIZE, 21, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 96, Short.MAX_VALUE)
                .addGap(35, 35, 35))
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(54, 54, 54)
                .addComponent(jbtnInsertarTDestino)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 113, Short.MAX_VALUE)
                .addComponent(jbtnInsertarTOrigen)
                .addGap(68, 68, 68))
        );

        jTabReqInformacion.addTab("Rastreabilidad", jPanel1);

        jbtnAceptar.setText("Aceptar");
        jbtnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAceptarActionPerformed(evt);
            }
        });

        jbtnCancelar.setText("Cancelar");
        jbtnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabReqInformacion, javax.swing.GroupLayout.PREFERRED_SIZE, 409, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jbtnAceptar, javax.swing.GroupLayout.DEFAULT_SIZE, 75, Short.MAX_VALUE)
                    .addComponent(jbtnCancelar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(25, 25, 25)
                .addComponent(jbtnAceptar, javax.swing.GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jbtnCancelar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(261, 261, 261))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabReqInformacion)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * jbtnCancelarActionPerformed Activa el boton cancelar
     * @param evt
     */
    private void jbtnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnCancelarActionPerformed
        jfaux.LeeArbol();
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_jbtnCancelarActionPerformed

    /**
     * formWindowClosed es el metodo que se activa cuando pulsamos la x de cerrar
     * @param evt
     */
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_formWindowClosed

    /**
     * jbtnAceptarActionPerformed Activa el boton aceptar
     * @param evt
     */
    private void jbtnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAceptarActionPerformed
        String ident;
        int i, j=0;
        ident=jtxtId.getText();
        if (jlstTDestino.getComponentCount() != 0) {
            for (int p = 0; p < jlstTDestino.getModel().getSize(); p++) {
                auxLD.add(jlstTDestino.getModel().getElementAt(p).toString());
            }
        }
        if (jlstTOrigen.getComponentCount() != 0) {
            for (int p = 0; p < jlstTOrigen.getModel().getSize(); p++) {
                auxLO.add(jlstTOrigen.getModel().getElementAt(p).toString());
            }
        }
        int l=0;
        if (!editar) {
            int cont = auxDocPpal.getLIdentRI().size();
            i = auxDocPpal.getRequisitoInformacion().size();
            if (i == cont) {
                i = i + 1;
                auxDocPpal.getLIdentRI().add(1);
            } else {
                for (l = 0; l < cont; l++) {
                    if (auxDocPpal.getLIdentRI().get(l) == 0) {
                        i = l + 1;
                        auxDocPpal.getLIdentRI().set(l, 1);
                    }
                }
            }
            newRI = auxDocPpal.nuevoRI(i, jtxtNombre.getText(), jtxaConcepto.getText(), Integer.parseInt(jtxtValorMax.getText()), jtxtUnMax.getText(), Integer.parseInt(jtxtValorMe.getText()), jtxtUnMe.getText(), Integer.parseInt(jtxtNumMax.getText()), Integer.parseInt(jtxtNumMe.getText()), jcbImportancia.getSelectedItem().toString(), jcbUrgencia.getSelectedItem().toString(), jcbEstado.getSelectedItem().toString(), jcbEstabilidad.getSelectedItem().toString(), auxLD, auxLO);
            MutableTreeNode node = new DefaultMutableTreeNode(newRI.getIdent());
            DefaultTreeModel model = (DefaultTreeModel) jfaux.getJtreDocumento().getModel();
            model.insertNodeInto(node, auxinsertNode, auxinsertIndex);
            jfaux.LeeArbol();
            mostrarmensaje("Insertado el Req Inf " + newRI.getNombre());
            jfaux.setEnabled(true);
            this.dispose();
        } else {
            boolean encontrado = false;
            i = 0;
            while (i < auxDocPpal.getRequisitoInformacion().size() && encontrado == false) {
                if (auxDocPpal.getRequisitoInformacion().get(i).getIdent().equals(ident)) {
                    encontrado = true;
                    j = i;
                    auxDocPpal.getRequisitoInformacion().remove(i);
                    newRI = auxDocPpal.nuevoRI(j+1, jtxtNombre.getText(), jtxaConcepto.getText(), Integer.parseInt(jtxtValorMax.getText()), jtxtUnMax.getText(), Integer.parseInt(jtxtValorMe.getText()), jtxtUnMe.getText(), Integer.parseInt(jtxtNumMax.getText()), Integer.parseInt(jtxtNumMe.getText()), jcbImportancia.getSelectedItem().toString(), jcbUrgencia.getSelectedItem().toString(), jcbEstado.getSelectedItem().toString(), jcbEstabilidad.getSelectedItem().toString(), auxLD, auxLO);
                    auxDocPpal.getRequisitoInformacion().get(i).setDatoEspecifico(auxRI.getDatoEspecifico());
                }
                i++;
            }
            jfaux.LeeArbol();
            mostrarmensaje("Insertado el Req Inf " + newRI.getNombre());
            jfaux.setEnabled(true);
            this.dispose();
        }
    }//GEN-LAST:event_jbtnAceptarActionPerformed

    /**
     * jbtnInsertarTDestinoActionPerformed Activa el boton insertar traza de destino
     * @param evt
     */
    private void jbtnInsertarTDestinoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnInsertarTDestinoActionPerformed
        jfrmAnadirTD jfTD = new jfrmAnadirTD(this, auxDocPpal, jlstTDestino, jtxtId.getText());
        jfTD.setVisible(true);
        this.setEnabled(false);
}//GEN-LAST:event_jbtnInsertarTDestinoActionPerformed

    /**
     * jbtnInsertarTOrigenActionPerformed Activa el boton insertar traza de origen
     * @param evt
     */
    private void jbtnInsertarTOrigenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnInsertarTOrigenActionPerformed
        jfrmAnadirTO jfTO = new jfrmAnadirTO(this, auxDocPpal, jlstTOrigen, jtxtId.getText());
        jfTO.setVisible(true);
        this.setEnabled(false);
}//GEN-LAST:event_jbtnInsertarTOrigenActionPerformed

    /**
    * @param args the command line arguments
    */
    /*public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
    public void run() {
    new jfrmReqInformacion().setVisible(true);
    }
    });
    }*/

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JTabbedPane jTabReqInformacion;
    private javax.swing.JButton jbtnAceptar;
    private javax.swing.JButton jbtnCancelar;
    private javax.swing.JButton jbtnInsertarTDestino;
    private javax.swing.JButton jbtnInsertarTOrigen;
    private javax.swing.JComboBox jcbEstabilidad;
    private javax.swing.JComboBox jcbEstado;
    private javax.swing.JComboBox jcbImportancia;
    private javax.swing.JComboBox jcbUrgencia;
    private javax.swing.JLabel jlbConcepto;
    private javax.swing.JLabel jlbEstDesarrollo;
    private javax.swing.JLabel jlbEstabilidad;
    private javax.swing.JLabel jlbImportancia;
    private javax.swing.JLabel jlbNombre;
    private javax.swing.JLabel jlbNumMax;
    private javax.swing.JLabel jlbNumMedio;
    private javax.swing.JLabel jlbOcurrencias;
    private javax.swing.JLabel jlbTiempoMaximo;
    private javax.swing.JLabel jlbTiempoMedio;
    private javax.swing.JLabel jlbUnTiempo;
    private javax.swing.JLabel jlbUnidadTiempo;
    private javax.swing.JLabel jlbUrgencia;
    private javax.swing.JLabel jlbVal;
    private javax.swing.JLabel jlbValor;
    private javax.swing.JList jlstTDestino;
    private javax.swing.JList jlstTOrigen;
    private javax.swing.JPanel jpanGeneral;
    private javax.swing.JPanel jpanPrioridad;
    private javax.swing.JTextArea jtxaConcepto;
    private javax.swing.JTextField jtxtId;
    private javax.swing.JTextField jtxtNombre;
    private javax.swing.JTextField jtxtNumMax;
    private javax.swing.JTextField jtxtNumMe;
    private javax.swing.JTextField jtxtUnMax;
    private javax.swing.JTextField jtxtUnMe;
    private javax.swing.JTextField jtxtValorMax;
    private javax.swing.JTextField jtxtValorMe;
    // End of variables declaration//GEN-END:variables

    /**
     * Muestra un mensaje en un JOptionPane
     * @param mensaje a mostrar en el JOptionPane
     */
    private void mostrarmensaje(String mensaje) {
         JOptionPane.showMessageDialog(this, mensaje, "Advertencia",
                                JOptionPane.WARNING_MESSAGE);
        }

    /**
     * update Método que es llamado cuando el objeto observado cambia
     * @param o objeto observable
     * @param arg argumento pasado al método notifyObservers
     */
    public void update(Observable o, Object arg) {
        jtxtNombre.setText(String.valueOf(newRI.getNombre()));
        jtxaConcepto.setText(String.valueOf(newRI.getConcepto()));
        jtxtValorMax.setText(String.valueOf(newRI.getValorMax()));
        jtxtValorMe.setText(String.valueOf(newRI.getValorMe()));
        jtxtUnMax.setText(String.valueOf(newRI.getUnidadTMax()));
        jtxtUnMe.setText(String.valueOf(newRI.getUnidadTMe()));
        jtxtNumMax.setText(String.valueOf(newRI.getNumeroMax()));
        jtxtNumMe.setText(String.valueOf(newRI.getNumeroMe()));
        jcbImportancia.setSelectedItem(String.valueOf(newRI.getImportancia()));
        jcbUrgencia.setSelectedItem(String.valueOf(newRI.getUrgencia()));
        jcbEstado.setSelectedItem(String.valueOf(newRI.getEstado()));
        jcbEstabilidad.setSelectedItem(String.valueOf(newRI.getEstabilidad()));
    }
}
