/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * jfrmReqRestriccion.java
 *
 * Created on 13-dic-2011, 23:22:19
 */

package vista;

import java.util.ArrayList;
import java.util.Observable;
import java.util.Observer;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import modelo.DocumentoReq;
import modelo.RequisitoRestriccion;

/**
 * jfrmReqRestriccion es el formulario con el cual podremos insertar todas las variables del requisito de restriccion
 */
public class jfrmReqRestriccion extends javax.swing.JFrame implements Observer {
    DocumentoReq auxDocPpal;
    jfrmPrincipal jfaux;
    RequisitoRestriccion newRR;
    MutableTreeNode auxinsertNode;
    int auxinsertIndex;
    ArrayList <String> auxLD = new ArrayList();
    ArrayList <String> auxLO = new ArrayList();
    private boolean editar=false;
    MutableTreeNode parent;
    int insertIndex2;

    /**
     * Constructor de JFrame ReqRestriccion
     * @param jf es el formulario principal
     * @param docPpal es el documento donde se guardan todas las variables
     * @param insertNode el nodo a insertar
     * @param insertIndex el indice del nodo a insertar
     */
    public jfrmReqRestriccion(jfrmPrincipal jf,DocumentoReq docPpal, MutableTreeNode insertNode, int insertIndex) {
        auxinsertNode=insertNode;
        auxinsertIndex=insertIndex;
        jfaux=jf;
        auxDocPpal=docPpal;
        this.setIconImage(new ImageIcon("src/imagenes/restriccion.jpg").getImage());
        initComponents();
        int l = 0, i=0;
        int cont = auxDocPpal.getLIdentRR().size();
        i = auxDocPpal.getRequisitoRestriccion().size();
        if (i == cont) {
            i = i + 1;
        } else {
            for (l = 0; l < cont; l++) {
                if (auxDocPpal.getLIdentRR().get(l) == 0) {
                    i = l + 1;
                }
            }
        }
        String ident;
        ident ="RRE"+String.valueOf(i);
        jtxtId.setText(ident);
    }

    /**
     * editarPropiedades Método que edita las propiedades de un requisito de restriccion
     * @param RR requisito de restriccion para editar
     */
    void editarPropiedades(RequisitoRestriccion RR) {
        editar = true;
        jtxtId.setText(RR.getIdent());
        DefaultListModel listModel = new DefaultListModel();
        DefaultListModel listModel2 = new DefaultListModel();
        jtxtNombre.setText(RR.getNombre());
        jtxaDescripcion.setText(RR.getDescripcion());
        jcbImportancia.setSelectedItem(RR.getImportancia());
        jcbUrgencia.setSelectedItem(RR.getUrgencia());
        jcbEstado.setSelectedItem(RR.getEstado());
        jcbEstabilidad.setSelectedItem(RR.getEstabilidad());
        if (RR.getMDestino().size() != 0) {
            jlstTDestino.setModel(listModel);
            for (int i = 0; i < RR.getMDestino().size(); i++) {
                listModel.add(i, RR.getMDestino().get(i));
            }
            
        }
        if (RR.getMOrigen().size() != 0) {
            jlstTOrigen.setModel(listModel2);
            for (int i = 0; i < RR.getMOrigen().size(); i++) {
                listModel2.add(i, RR.getMOrigen().get(i));
            }
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabReqRestriccion = new javax.swing.JTabbedPane();
        jpanGeneral = new javax.swing.JPanel();
        jlbNombre = new javax.swing.JLabel();
        jtxtNombre = new javax.swing.JTextField();
        jlbDescripcion = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtxaDescripcion = new javax.swing.JTextArea();
        jtxtId = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        jpanPrioridad = new javax.swing.JPanel();
        jlbImportancia = new javax.swing.JLabel();
        jlbUrgencia = new javax.swing.JLabel();
        jlbEstDesarrollo = new javax.swing.JLabel();
        jlbEstabilidad = new javax.swing.JLabel();
        jcbImportancia = new javax.swing.JComboBox();
        jcbUrgencia = new javax.swing.JComboBox();
        jcbEstado = new javax.swing.JComboBox();
        jcbEstabilidad = new javax.swing.JComboBox();
        jPanel1 = new javax.swing.JPanel();
        jbtnInsertarTDestino = new javax.swing.JButton();
        jbtnInsertarTOrigen = new javax.swing.JButton();
        jScrollPane5 = new javax.swing.JScrollPane();
        jlstTOrigen = new javax.swing.JList();
        jLabel13 = new javax.swing.JLabel();
        jScrollPane4 = new javax.swing.JScrollPane();
        jlstTDestino = new javax.swing.JList();
        jLabel12 = new javax.swing.JLabel();
        jbtnAceptar = new javax.swing.JButton();
        jbtnCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Requisito de Restricción");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jlbNombre.setText("Nombre");

        jlbDescripcion.setText("Descripción");

        jtxaDescripcion.setColumns(20);
        jtxaDescripcion.setRows(5);
        jtxaDescripcion.setText("PD");
        jScrollPane1.setViewportView(jtxaDescripcion);

        jtxtId.setEditable(false);

        jLabel14.setText("Identificador:");

        javax.swing.GroupLayout jpanGeneralLayout = new javax.swing.GroupLayout(jpanGeneral);
        jpanGeneral.setLayout(jpanGeneralLayout);
        jpanGeneralLayout.setHorizontalGroup(
            jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanGeneralLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 413, Short.MAX_VALUE)
                            .addComponent(jlbDescripcion)
                            .addGroup(jpanGeneralLayout.createSequentialGroup()
                                .addComponent(jlbNombre)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jtxtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, 226, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addContainerGap())
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jLabel14, javax.swing.GroupLayout.DEFAULT_SIZE, 65, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jtxtId, javax.swing.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE)
                        .addGap(256, 256, 256))))
        );
        jpanGeneralLayout.setVerticalGroup(
            jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanGeneralLayout.createSequentialGroup()
                .addGap(11, 11, 11)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtxtId)
                    .addComponent(jLabel14, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlbNombre)
                    .addComponent(jtxtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jlbDescripcion)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 177, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTabReqRestriccion.addTab("General", jpanGeneral);

        jlbImportancia.setText("Importancia");

        jlbUrgencia.setText("Urgencia");

        jlbEstDesarrollo.setText("Estado de desarrollo");

        jlbEstabilidad.setText("Estabilidad");

        jcbImportancia.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PD", "vital", "importante" }));

        jcbUrgencia.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PD ", "inmediata", "hay presión", " " }));

        jcbEstado.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PD", "en construcción", "pendiente de verificación" }));

        jcbEstabilidad.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PD", "baja ", "media", " " }));

        javax.swing.GroupLayout jpanPrioridadLayout = new javax.swing.GroupLayout(jpanPrioridad);
        jpanPrioridad.setLayout(jpanPrioridadLayout);
        jpanPrioridadLayout.setHorizontalGroup(
            jpanPrioridadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanPrioridadLayout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(jpanPrioridadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpanPrioridadLayout.createSequentialGroup()
                        .addComponent(jlbEstabilidad)
                        .addContainerGap())
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jpanPrioridadLayout.createSequentialGroup()
                        .addGroup(jpanPrioridadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jcbEstabilidad, javax.swing.GroupLayout.Alignment.LEADING, 0, 386, Short.MAX_VALUE)
                            .addComponent(jcbImportancia, javax.swing.GroupLayout.Alignment.LEADING, 0, 386, Short.MAX_VALUE)
                            .addComponent(jlbImportancia, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jlbUrgencia, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jcbUrgencia, javax.swing.GroupLayout.Alignment.LEADING, 0, 386, Short.MAX_VALUE)
                            .addComponent(jlbEstDesarrollo, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jcbEstado, javax.swing.GroupLayout.Alignment.LEADING, 0, 386, Short.MAX_VALUE))
                        .addContainerGap(27, javax.swing.GroupLayout.PREFERRED_SIZE))))
        );
        jpanPrioridadLayout.setVerticalGroup(
            jpanPrioridadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanPrioridadLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jlbImportancia)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jcbImportancia, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jlbUrgencia)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jcbUrgencia, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jlbEstDesarrollo)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jcbEstado, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jlbEstabilidad)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jcbEstabilidad, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(41, Short.MAX_VALUE))
        );

        jTabReqRestriccion.addTab("Prioridad", jpanPrioridad);

        jbtnInsertarTDestino.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/insertTD.jpg"))); // NOI18N
        jbtnInsertarTDestino.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnInsertarTDestinoActionPerformed(evt);
            }
        });

        jbtnInsertarTOrigen.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/insertTO.jpg"))); // NOI18N
        jbtnInsertarTOrigen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnInsertarTOrigenActionPerformed(evt);
            }
        });

        jScrollPane5.setViewportView(jlstTOrigen);

        jLabel13.setText("Trazas Origen");

        jScrollPane4.setViewportView(jlstTDestino);

        jLabel12.setText("Trazas Destino");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGap(2, 2, 2)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(11, 11, 11)
                        .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 314, Short.MAX_VALUE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, 121, Short.MAX_VALUE)
                        .addGap(204, 204, 204))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel13, javax.swing.GroupLayout.DEFAULT_SIZE, 117, Short.MAX_VALUE)
                        .addGap(208, 208, 208))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 315, Short.MAX_VALUE)))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jbtnInsertarTDestino, 0, 0, Short.MAX_VALUE)
                    .addComponent(jbtnInsertarTOrigen, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(44, 44, 44))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, 14, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 83, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel13, javax.swing.GroupLayout.DEFAULT_SIZE, 14, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 91, Short.MAX_VALUE)
                .addGap(35, 35, 35))
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(54, 54, 54)
                .addComponent(jbtnInsertarTDestino)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 91, Short.MAX_VALUE)
                .addComponent(jbtnInsertarTOrigen)
                .addGap(68, 68, 68))
        );

        jTabReqRestriccion.addTab("Rastreabilidad", jPanel1);

        jbtnAceptar.setText("Aceptar");
        jbtnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAceptarActionPerformed(evt);
            }
        });

        jbtnCancelar.setText("Cancelar");
        jbtnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabReqRestriccion, javax.swing.GroupLayout.DEFAULT_SIZE, 438, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jbtnAceptar, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jbtnCancelar, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jbtnAceptar)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jTabReqRestriccion)
                        .addContainerGap())
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jbtnCancelar)
                        .addGap(248, 248, 248))))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * jbtnCancelarActionPerformed Activa el boton cancelar
     * @param evt
     */
    private void jbtnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnCancelarActionPerformed
        jfaux.LeeArbol();
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_jbtnCancelarActionPerformed

    /**
     * jbtnAceptarActionPerformed Activa el boton aceptar
     * @param evt
     */
    private void jbtnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAceptarActionPerformed
        String ident;
        int i, j=0;
        ident=jtxtId.getText();
        if (jlstTDestino.getComponentCount() != 0) {
            for (int p = 0; p < jlstTDestino.getModel().getSize(); p++) {
                auxLD.add(jlstTDestino.getModel().getElementAt(p).toString());
            }
        }
        if (jlstTOrigen.getComponentCount() != 0) {
            for (int p = 0; p < jlstTOrigen.getModel().getSize(); p++) {
                auxLO.add(jlstTOrigen.getModel().getElementAt(p).toString());
            }
        }
        int l=0;
        if (!editar) {
            int cont = auxDocPpal.getLIdentRR().size();
            i = auxDocPpal.getRequisitoRestriccion().size();
            if (i == cont) {
                i = i + 1;
                auxDocPpal.getLIdentRR().add(1);
            } else {
                for (l = 0; l < cont; l++) {
                    if (auxDocPpal.getLIdentRR().get(l) == 0) {
                        i = l + 1;
                        auxDocPpal.getLIdentRR().set(l, 1);
                    }
                }
            }
            newRR = auxDocPpal.nuevoRes(i, jtxtNombre.getText(), jtxaDescripcion.getText(), jcbImportancia.getSelectedItem().toString(), jcbUrgencia.getSelectedItem().toString(), jcbEstado.getSelectedItem().toString(), jcbEstabilidad.getSelectedItem().toString(), auxLD, auxLO);
            MutableTreeNode node = new DefaultMutableTreeNode(newRR.getIdent());
            DefaultTreeModel model = (DefaultTreeModel) jfaux.getJtreDocumento().getModel();
            model.insertNodeInto(node, auxinsertNode, auxinsertIndex);
            jfaux.LeeArbol();
            mostrarmensaje("Insertado el Req Res " + newRR.getNombre());
            jfaux.setEnabled(true);
            this.dispose();
        } else {
            boolean encontrado = false;
            i = 0;
            while (i < auxDocPpal.getRequisitoRestriccion().size() && encontrado == false) {
                if (auxDocPpal.getRequisitoRestriccion().get(i).getIdent().equals(ident)) {
                    encontrado = true;
                    j = i;
                    auxDocPpal.getRequisitoRestriccion().remove(i);
                    newRR = auxDocPpal.nuevoRes(j+1, jtxtNombre.getText(), jtxaDescripcion.getText(), jcbImportancia.getSelectedItem().toString(), jcbUrgencia.getSelectedItem().toString(), jcbEstado.getSelectedItem().toString(), jcbEstabilidad.getSelectedItem().toString(), auxLD, auxLO);
                }
                i++;
            }
            jfaux.LeeArbol();
            mostrarmensaje("Insertado el Req Res " + newRR.getNombre());
            jfaux.setEnabled(true);
            this.dispose();
        }
    }//GEN-LAST:event_jbtnAceptarActionPerformed

    /**
     * formWindowClosed es el metodo que se activa cuando pulsamos la x de cerrar
     * @param evt
     */
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_formWindowClosed

    /**
     * jbtnInsertarTDestinoActionPerformed Activa el boton insertar traza de destino
     * @param evt
     */
    private void jbtnInsertarTDestinoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnInsertarTDestinoActionPerformed
        jfrmAnadirTD jfTD = new jfrmAnadirTD(this, auxDocPpal, jlstTDestino, jtxtId.getText());
        jfTD.setVisible(true);
        this.setEnabled(false);
}//GEN-LAST:event_jbtnInsertarTDestinoActionPerformed

    /**
     * jbtnInsertarTOrigenActionPerformed Activa el boton insertar traza de origen
     * @param evt
     */
    private void jbtnInsertarTOrigenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnInsertarTOrigenActionPerformed
        jfrmAnadirTO jfTO = new jfrmAnadirTO(this, auxDocPpal, jlstTOrigen, jtxtId.getText());
        jfTO.setVisible(true);
        this.setEnabled(false);
}//GEN-LAST:event_jbtnInsertarTOrigenActionPerformed

    /**
    * @param args the command line arguments
    */
    /*public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
    public void run() {
    new jfrmReqRestriccion().setVisible(true);
    }
    });
    }*/

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JTabbedPane jTabReqRestriccion;
    private javax.swing.JButton jbtnAceptar;
    private javax.swing.JButton jbtnCancelar;
    private javax.swing.JButton jbtnInsertarTDestino;
    private javax.swing.JButton jbtnInsertarTOrigen;
    private javax.swing.JComboBox jcbEstabilidad;
    private javax.swing.JComboBox jcbEstado;
    private javax.swing.JComboBox jcbImportancia;
    private javax.swing.JComboBox jcbUrgencia;
    private javax.swing.JLabel jlbDescripcion;
    private javax.swing.JLabel jlbEstDesarrollo;
    private javax.swing.JLabel jlbEstabilidad;
    private javax.swing.JLabel jlbImportancia;
    private javax.swing.JLabel jlbNombre;
    private javax.swing.JLabel jlbUrgencia;
    private javax.swing.JList jlstTDestino;
    private javax.swing.JList jlstTOrigen;
    private javax.swing.JPanel jpanGeneral;
    private javax.swing.JPanel jpanPrioridad;
    private javax.swing.JTextArea jtxaDescripcion;
    private javax.swing.JTextField jtxtId;
    private javax.swing.JTextField jtxtNombre;
    // End of variables declaration//GEN-END:variables

    /**
     * Muestra un mensaje en un JOptionPane
     * @param mensaje a mostrar en el JOptionPane
     */
    private void mostrarmensaje(String mensaje) {
         JOptionPane.showMessageDialog(this, mensaje, "Advertencia",
                                JOptionPane.WARNING_MESSAGE);
        }

    /**
     * update Método que es llamado cuando el objeto observado cambia
     * @param o objeto observable
     * @param arg argumento pasado al método notifyObservers
     */
    public void update(Observable o, Object arg) {
        jtxtNombre.setText(String.valueOf(newRR.getNombre()));
        jtxaDescripcion.setText(String.valueOf(newRR.getDescripcion()));
        jcbImportancia.setSelectedItem(String.valueOf(newRR.getImportancia()));
        jcbUrgencia.setSelectedItem(String.valueOf(newRR.getUrgencia()));
        jcbEstado.setSelectedItem(String.valueOf(newRR.getEstado()));
        jcbEstabilidad.setSelectedItem(String.valueOf(newRR.getEstabilidad()));
    }
}