<?xml version="1.0" encoding="UTF-8"?>
<!--
Document : XMLDocumentoReq1.xsl
Created on : 19 de diciembre de 2011, 11:13
Author : manueldelavilla
Description:
Purpose of transformation follows.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
    <xsl:output method="html"/>
<!-- TODO customize transformation rules
syntax recommendation http://www.w3.org/TR/xslt
-->

    <xsl:template match="/">
        <xsl:for-each select="//DocumentoR">
            <h1><font size="1000" color="996699"><i><center><xsl:value-of select = "nombre"/></center></i></font></h1>
            <font size="40" color="996699"><i><center><br/><xsl:value-of select = "creado"/></center></i></font>
            <font size="40" color="996699"><i><center><br/><xsl:value-of select = "fecha"/></center></i></font>
            <font size="40" color="996699"><i><center><br/><xsl:value-of select = "preparado"/></center></i></font><br/>
            <HR WIDTH="100%" SIZE="5" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- CASO DE USO -->
        <xsl:for-each select="//CasodeUso">
            <b><i><font size="26" color="996699">Caso de Uso</font></i></b><br/>
            <table border="2" width="80%" align="Center">
                <tr>
                    <td bgcolor="996699" width="20%">
                        <b><i>Identificación</i></b>
                    </td>
                    <td>
                        <b>
                            <xsl:value-of select = "identificacion"/>
                        </b>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Nombre</i></b>
                    </td>
                    <td>
                        <b>
                            <xsl:value-of select = "nombre"/>
                        </b>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Unidad de frecuencia</i></b>
                    </td>
                    <td>
                        <xsl:value-of select = "unidadFrecuencia"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Frecuencia</i></b>
                    </td>
                    <td>
                        <xsl:value-of select = "frecuencia"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Evento de activación</i></b>
                    </td>
                    <td>
                        <xsl:value-of select = "eventoActivacion"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Precondición</i></b>
                    </td>
                    <td>
                        <xsl:value-of select = "precondicion"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Postcondición</i></b>
                    </td>
                    <td>
                        <xsl:value-of select = "postcondicion"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Importacia</i></b>
                    </td>
                    <td>
                        <xsl:value-of select = "importancia"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Urgencia</i></b>
                    </td>
                    <td>
                        <xsl:value-of select = "urgencia"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Estabilidad</i></b>
                    </td>
                    <td>
                        <xsl:value-of select = "estabilidad"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Estado de desarrollo</i></b>
                    </td>
                    <td>
                        <xsl:value-of select = "estadodeDesarrollo"/>
                    </td>
                </tr>
            <!-- PASO CASO DE USO -->
                <tr>
                    <td bgcolor="996699">
                        <b><i>Pasos</i></b>
                    </td>
                    <td>
                        <xsl:for-each select="./PasoCU">
                            <xsl:value-of select="identP"/>. <xsl:value-of select = "accionP"/><br/>
                       </xsl:for-each>
                    </td>
                </tr>
            <!-- EXCEPCION PASO CASO DE USO -->
                <tr>
                    <td bgcolor="996699">
                        <b><i>Excepciones</i></b>
                    </td>
                    <td>
                        <xsl:for-each select="//ExcepcionCU">
                            <xsl:value-of select="identE"/>. <xsl:value-of select = "accionE"/><br/>
                        </xsl:for-each>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="5" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- SECCION -->
        <xsl:for-each select="//Seccion">
            <b><i><font size="26" color="996699">Sección/Apéndice</font></i></b><br/>
            <table border="2" width="80%" align="Center">
                <tr>
                    <td bgcolor="996699" width="20%">
                        <b><i>Identificacion</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Nombre</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Seccion normal</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="seccionNormal"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Seccion apendice</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="seccionApendice"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Orden</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="orden"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Comentarios</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="comentarios"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="5" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- PARRAFO -->
        <xsl:for-each select="//Parrafo">
            <b><i><font size="26" color="996699">Párrafo/Glosario</font></i></b><br/>
            <table border="2" width="80%" align="Center">
                <tr>
                    <td bgcolor="996699" width="20%">
                        <b><i>Identificador</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Nombre</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Texto</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="texto"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Tipo de Párrafo</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="tipoparrafo"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Comentarios</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="comentarios"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="5" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- FICHERO GRAFICO -->
        <xsl:for-each select="//FicheroGrafico">
            <b><i><font size="26" color="996699">Fichero Gráfico</font></i></b><br/>
            <table border="2" width="80%" align="Center">
                <tr>
                    <td bgcolor="996699" width="20%">
                        <b><i>Identificador</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Nombre</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Fichero</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="fich"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Comentarios</i></b>
                    </td>

                    <td>
                        <xsl:value-of select="comentarios"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="5" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- ORGANIZACION -->
        <xsl:for-each select="//Organizacion">
            <b><i><font size="26" color="996699">Organización</font></i></b><br/>
            <table border="2" width="80%" align="Center">
                <tr>
                    <td bgcolor="996699" width="20%">
                        <b><i>Identificacion</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Nombre</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Dirección</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="direccion"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Teléfono</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="tlfn"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Fax</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="fax"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Participantes</i></b>
                    </td>
                    <td>
                        <xsl:for-each select="//PartiO">
                            <xsl:value-of select="identP"/>. <xsl:value-of select="nombreP"/><br/>
                        </xsl:for-each>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Comentario</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="comentario"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="5" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- PARTICIPANTE -->
        <xsl:for-each select="//Participante">
            <b><i><font size="26" color="996699">Participante</font></i></b><br/>
            <table border="2" width="80%" align="Center">
                <tr>
                    <td bgcolor="996699" width="20%">
                        <b><i>Identificacion</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Nombre</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Rol</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="rol"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Organizacion</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="organizacion"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>EsCliente</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="esCliente"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>EsDesarrollador</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="esDesarrollador"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>EsUsuario</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="esUsuario"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="5" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- REUNION -->
        <xsl:for-each select="//Reunion">
            <b><i><font size="26" color="996699">Reunión</font></i></b><br/>
            <table border="2" width="80%" align="Center">
                <tr>
                    <td bgcolor="996699" width="20%">
                        <b><i>Identificación</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Nombre</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Lugar</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="LUGAR"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Fecha</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="fecha"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Asitentes</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="asistentes"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Resultados</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="resultados"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="5" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- REQUISITO DE RESTRICCION -->
        <xsl:for-each select="//RequisitoRestriccion">
            <b><i><font size="26" color="996699">Requisito de Restricción</font></i></b><br/>
            <table border="2" width="80%" align="Center">
                <tr>
                    <td bgcolor="996699" width="20%">
                        <b><i>Identificación</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Nombre</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Descripción</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="descripcion"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Importancia</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="importancia"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Urgencia</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="urgencia"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Estado de desarrollo</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="estado"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Estabilidad</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="estabilidad"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="5" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- REQUISITO DE INFORMACION -->
        <xsl:for-each select="//RequisitoInformacion">
            <b><i><font size="26" color="996699">Requisito de Información</font></i></b><br/>
            <table border="2" width="80%" align="Center">
                <tr>
                    <td bgcolor="996699" width="20%">
                        <b><i>Identificación</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Nombre</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="Nombre"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Concepto</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="concepto"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Valor Max.</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="valorMax"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Unidad tiempo Max.</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="unidadTMax"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Valor medio</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="valorMed"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Unidad de tiempo Medio</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="unidadTMe"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Número Max.</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="numeroMax"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Número Medio</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="numeroMed"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Importancia</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="importancia"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Urgencia</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="urgencia"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Estado de desarrollo</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="estado"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Estabilidad</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="estabilidad"/>
                    </td>
                </tr>
            <!-- DATO ESPECIFICO -->
                <tr>
                    <td bgcolor="996699">
                        <b><i>Descripción Dato Especifico</i></b>
                    </td>
                    <td>
                        <xsl:for-each select=".//DatoEsp">
                            <xsl:value-of select="ident"/>. <xsl:value-of select="descripcion"/><br/>
                        </xsl:for-each>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="5" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- REQUISITO FUNCIONAL -->
    <xsl:for-each select="//RequisitoFuncional">
        <b><i><font size="26" color="996699">Requisito funcional</font></i></b><br/>
        <table border="2" width="80%" align="Center">
            <tr>
                <td bgcolor="996699" width="20%">
                    <b><i>Identificación</i></b>
                </td>
                <td>
                    <xsl:value-of select="ident"/>
                </td>
            </tr>
            <tr>
                <td bgcolor="996699">
                    <b><i>Nombre</i></b>
                </td>
                <td>
                    <xsl:value-of select="nombre"/>
                </td>
            </tr>
            <tr>
                <td bgcolor="996699">
                    <b><i>Descripción</i></b>
                </td>
                <td>
                    <xsl:value-of select="descripcion"/>
                </td>
            </tr>
            <tr>
                    <td bgcolor="996699">
                        <b><i>Importancia</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="importancia"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Urgencia</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="urgencia"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Estado de desarrollo</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="estado"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Estabilidad</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="estabilidad"/>
                    </td>
                </tr>
        </table>
        <HR WIDTH="100%" SIZE="5" ALIGN="Center"></HR>
    </xsl:for-each>
<!-- REQUISITO NO FUNCIONAL -->
    <xsl:for-each select="//RequisitoNoFuncional">
        <b><i><font size="26" color="996699">Requisito no funcional</font></i></b><br/>
        <table border="2" width="80%" align="Center">
            <tr>
                <td bgcolor="996699" width="20%">
                    <b><i>Identificación</i></b>
                </td>
                <td>
                    <xsl:value-of select="ident"/>
                </td>
            </tr>
            <tr>
                <td bgcolor="996699">
                    <b><i>Nombre</i></b>
                </td>
                <td>
                    <xsl:value-of select="nombre"/>
                </td>
            </tr>
            <tr>
                <td bgcolor="996699">
                    <b><i>Descripción</i></b>
                </td>
                <td>
                    <xsl:value-of select="descripcion"/>
                </td>
            </tr>
            <tr>
                    <td bgcolor="996699">
                        <b><i>Importancia</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="importancia"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Urgencia</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="urgencia"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Estado de desarrollo</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="estado"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Estabilidad</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="estabilidad"/>
                    </td>
                </tr>
        </table>
        <HR WIDTH="100%" SIZE="5" ALIGN="Center"></HR>
    </xsl:for-each>
<!-- ACTOR -->
    <xsl:for-each select="//Actor">
            <b><i><font size="26" color="996699">Actor</font></i></b><br/>
            <table border="2" width="80%" align="Center">
                <tr>
                    <td bgcolor="996699" width="20%">
                        <b><i>Identificación</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="identificacion"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Nombre</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>

                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Descripcion</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="descripcion"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="5" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- OBJETIVO -->
        <xsl:for-each select="//Objetivo">
            <b><i><font size="26" color="996699">Objetivo</font></i></b><br/>
            <table border="2" width="80%" align="Center">
                <tr>
                    <td bgcolor="996699" width="20%">
                        <b><i>Identificación</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Nombre</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Descripcion</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="descripcion"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Importancia</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="importancia"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Urgencia</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="urgencia"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Estado</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="estado"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b><i>Estabilidad</i></b>
                    </td>
                    <td>
                        <xsl:value-of select="estabilidad"/>
                    </td>
                </tr>
            <!-- SUBOBJETIVO -->
                <tr>
                    <td bgcolor="996699">
                        <b><i>Subobjetivos</i></b>
                    </td>
                    <td>
                        <xsl:for-each select=".//Subobjetivo">
                            <xsl:value-of select="identSO"/>. <xsl:value-of select = "descripcionSO"/><br/>
                        </xsl:for-each>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="5" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- MATRIZ DE RASTREABILIDAD -->
        <xsl:for-each select="//MatrizRastreabilidad">
            <b><font size="26" color="996699">Matriz de Rastreabilidad</font></b><br/>
            <table border="2" width="80%" align="Center">
                <tr>
                    <td bgcolor="996699" width="20%">
                        <b>Nombre</b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="996699">
                        <b>Comentarios</b>
                    </td>
                    <td>
                        <xsl:value-of select="comentarios"/>
                    </td>
                </tr>
            </table>
            <table border="2" align="Center">
                <tr>
                    <th bgcolor="996699">
                        <xsl:value-of select="ident"/>
                    </th>
                    <xsl:for-each select="//mColumna">
                        <th bgcolor="996699">
                            <xsl:value-of select="cm"/><br/>
                        </th>
                    </xsl:for-each>
                </tr>
                <xsl:for-each select="//mFila">
                    <tr>
                        <th bgcolor="996699">
                            <xsl:value-of select="fm"/><br/>
                        </th>
                        <xsl:for-each select="./aux">
                            <td>
                                <xsl:if test="./traza = 'tr2'">*</xsl:if>
                                <xsl:if test="./traza = 'tr1'">-</xsl:if>
                            </td>
                        </xsl:for-each>
                    </tr>
                </xsl:for-each>
            </table>
            <HR WIDTH="100%" SIZE="5" ALIGN="Center"></HR>
        </xsl:for-each>
    </xsl:template>
</xsl:stylesheet>