/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * jfrmCasodeUso.java
 *
 * Created on 22-nov-2011, 17:05:03
 */

package vista;

import java.util.ArrayList;
import java.util.List;
import java.util.Observable;
import java.util.Observer;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import modelo.*;

/**
 * jfrmCasodeUso es el formulario con el cual podremos insertar todas las variables del Caso de Uso
 */
public class jfrmCasodeUso extends javax.swing.JFrame implements Observer {

    DocumentoReq auxDocPpal;
    jfrmPrincipal jfaux;
    private boolean editar = false;
    MutableTreeNode auxinsertNode;
    int auxinsertIndex;
    CasodeUso newCU;
    CasodeUso auxCU;
    PasoCU auxP;
    int m;
    List<ExcepcionCU> auxEX = new ArrayList();
    List<PasoCU> auxPasos = new ArrayList();
    MutableTreeNode parent;
    int insertIndex2;

    /**
     * Constructor de JFrame CasodeUso
     * @param jf es el formulario principal
     * @param docPpal es el documento donde se guardan todas las variables
     * @param insertNode el nodo a insertar
     * @param insertIndex el indice del nodo a insertar
     */

  
    @SuppressWarnings("static-access")
    public jfrmCasodeUso(jfrmPrincipal jf, DocumentoReq docPpal, MutableTreeNode insertNode, int insertIndex) {
        auxinsertNode = insertNode;
        auxinsertIndex = insertIndex;
        jfaux = jf;
        auxDocPpal = docPpal;
        this.setIconImage(new ImageIcon("src/imagenes/casouso.jpg").getImage());
        initComponents();
        int l = 0, i=0;
        if(auxDocPpal.getCasodeUso().size()!=0){
            l = auxDocPpal.getCasodeUso().size();
            l--;
            i = auxDocPpal.getCasodeUso().get(l).getId_n();
        } else {
            i=0;
        }
        String ident;
        ident ="CU"+String.valueOf(i+1);
        jtxtId.setText(ident);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabCU = new javax.swing.JTabbedPane();
        jpanGeneral = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jtxtNombreCU = new javax.swing.JTextField();
        jchbesAbstracto = new javax.swing.JCheckBox();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtxaEventoActivacion = new javax.swing.JTextArea();
        jtxtFrecuencia = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jtxtUnidadFrecuencia = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jtxtId = new javax.swing.JTextField();
        jpanPrePost = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jtxaPrecondicion = new javax.swing.JTextArea();
        jLabel6 = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jtxaPostcondicion = new javax.swing.JTextArea();
        jpanPrioridad = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jcbImportancia = new javax.swing.JComboBox();
        jcbUrgencia = new javax.swing.JComboBox();
        jcbEstado = new javax.swing.JComboBox();
        jLabel11 = new javax.swing.JLabel();
        jcbEstabilidad = new javax.swing.JComboBox();
        jbtnAceptar = new javax.swing.JButton();
        jbtnCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Caso de Uso");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jLabel1.setText("Nombre:");

        jchbesAbstracto.setText("CU Abstracto");

        jLabel2.setText("Evento de activacion:");

        jtxaEventoActivacion.setColumns(20);
        jtxaEventoActivacion.setRows(5);
        jScrollPane1.setViewportView(jtxaEventoActivacion);

        jtxtFrecuencia.setText("0");

        jLabel4.setText("veces al ");

        jtxtUnidadFrecuencia.setText("PD");

        jLabel3.setText("Frecuencia:");

        jLabel12.setText("Identificador:");

        jtxtId.setEditable(false);

        javax.swing.GroupLayout jpanGeneralLayout = new javax.swing.GroupLayout(jpanGeneral);
        jpanGeneral.setLayout(jpanGeneralLayout);
        jpanGeneralLayout.setHorizontalGroup(
            jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanGeneralLayout.createSequentialGroup()
                .addGap(32, 32, 32)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jtxtFrecuencia, javax.swing.GroupLayout.DEFAULT_SIZE, 43, Short.MAX_VALUE)
                        .addGap(22, 22, 22)
                        .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jtxtUnidadFrecuencia, javax.swing.GroupLayout.DEFAULT_SIZE, 67, Short.MAX_VALUE)
                        .addGap(110, 110, 110))
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 344, Short.MAX_VALUE)
                        .addContainerGap())
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, 344, Short.MAX_VALUE)
                        .addContainerGap())
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jchbesAbstracto, javax.swing.GroupLayout.DEFAULT_SIZE, 243, Short.MAX_VALUE)
                        .addGap(111, 111, 111))
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jpanGeneralLayout.createSequentialGroup()
                                .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, 65, Short.MAX_VALUE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jtxtId, javax.swing.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE)
                                .addGap(145, 145, 145))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jpanGeneralLayout.createSequentialGroup()
                                .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 57, Short.MAX_VALUE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jtxtNombreCU, javax.swing.GroupLayout.DEFAULT_SIZE, 251, Short.MAX_VALUE)))
                        .addGap(42, 42, 42))))
        );
        jpanGeneralLayout.setVerticalGroup(
            jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jpanGeneralLayout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtxtId)
                    .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtxtNombreCU)
                    .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jchbesAbstracto, javax.swing.GroupLayout.PREFERRED_SIZE, 20, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 36, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addGap(6, 6, 6)
                        .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addGap(6, 6, 6)
                        .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jtxtFrecuencia)
                        .addComponent(jtxtUnidadFrecuencia)))
                .addGap(49, 49, 49))
        );

        jTabCU.addTab("General", jpanGeneral);

        jLabel5.setText("Precondicion:");

        jtxaPrecondicion.setColumns(20);
        jtxaPrecondicion.setRows(5);
        jScrollPane2.setViewportView(jtxaPrecondicion);

        jLabel6.setText("Postcondicion:");

        jtxaPostcondicion.setColumns(20);
        jtxaPostcondicion.setRows(5);
        jScrollPane3.setViewportView(jtxaPostcondicion);

        javax.swing.GroupLayout jpanPrePostLayout = new javax.swing.GroupLayout(jpanPrePost);
        jpanPrePost.setLayout(jpanPrePostLayout);
        jpanPrePostLayout.setHorizontalGroup(
            jpanPrePostLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanPrePostLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpanPrePostLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 337, Short.MAX_VALUE)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 337, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jpanPrePostLayout.createSequentialGroup()
                        .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(273, 273, 273))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jpanPrePostLayout.createSequentialGroup()
                        .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(268, 268, 268)))
                .addGap(39, 39, 39))
        );
        jpanPrePostLayout.setVerticalGroup(
            jpanPrePostLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanPrePostLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, 14, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 52, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, 14, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 51, Short.MAX_VALUE)
                .addGap(64, 64, 64))
        );

        jTabCU.addTab("Pre/Post", jpanPrePost);

        jLabel7.setText("Importancia:");

        jLabel8.setText("Urgencia:");

        jLabel9.setText("Estado de desarrollo:");

        jcbImportancia.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PD", "vital", "importante" }));

        jcbUrgencia.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PD ", "inmediata", "hay presión" }));

        jcbEstado.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PD", "en construcción", "pendiente de verificación" }));

        jLabel11.setText("Estabilidad:");

        jcbEstabilidad.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PD", "baja ", "media" }));

        javax.swing.GroupLayout jpanPrioridadLayout = new javax.swing.GroupLayout(jpanPrioridad);
        jpanPrioridad.setLayout(jpanPrioridadLayout);
        jpanPrioridadLayout.setHorizontalGroup(
            jpanPrioridadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanPrioridadLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpanPrioridadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpanPrioridadLayout.createSequentialGroup()
                        .addComponent(jLabel8, javax.swing.GroupLayout.DEFAULT_SIZE, 50, Short.MAX_VALUE)
                        .addGap(320, 320, 320))
                    .addGroup(jpanPrioridadLayout.createSequentialGroup()
                        .addComponent(jLabel7, javax.swing.GroupLayout.DEFAULT_SIZE, 65, Short.MAX_VALUE)
                        .addGap(305, 305, 305))
                    .addGroup(jpanPrioridadLayout.createSequentialGroup()
                        .addComponent(jLabel9, javax.swing.GroupLayout.DEFAULT_SIZE, 106, Short.MAX_VALUE)
                        .addGap(264, 264, 264))
                    .addComponent(jcbEstado, javax.swing.GroupLayout.Alignment.TRAILING, 0, 370, Short.MAX_VALUE)
                    .addComponent(jcbImportancia, 0, 370, Short.MAX_VALUE)
                    .addComponent(jcbUrgencia, javax.swing.GroupLayout.Alignment.TRAILING, 0, 370, Short.MAX_VALUE)
                    .addGroup(jpanPrioridadLayout.createSequentialGroup()
                        .addComponent(jLabel11, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(315, 315, 315))
                    .addComponent(jcbEstabilidad, 0, 370, Short.MAX_VALUE))
                .addContainerGap())
        );
        jpanPrioridadLayout.setVerticalGroup(
            jpanPrioridadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanPrioridadLayout.createSequentialGroup()
                .addGap(28, 28, 28)
                .addComponent(jLabel7)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jcbImportancia, javax.swing.GroupLayout.DEFAULT_SIZE, 18, Short.MAX_VALUE)
                .addGap(2, 2, 2)
                .addComponent(jLabel8, javax.swing.GroupLayout.DEFAULT_SIZE, 14, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jcbUrgencia, javax.swing.GroupLayout.DEFAULT_SIZE, 18, Short.MAX_VALUE)
                .addGap(8, 8, 8)
                .addComponent(jLabel9, javax.swing.GroupLayout.DEFAULT_SIZE, 14, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jcbEstado, javax.swing.GroupLayout.DEFAULT_SIZE, 18, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel11, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jcbEstabilidad, javax.swing.GroupLayout.DEFAULT_SIZE, 18, Short.MAX_VALUE)
                .addGap(122, 122, 122))
        );

        jTabCU.addTab("Prioridad", jpanPrioridad);

        jbtnAceptar.setText("Aceptar");
        jbtnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAceptarActionPerformed(evt);
            }
        });

        jbtnCancelar.setText("Cancelar");
        jbtnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabCU, javax.swing.GroupLayout.DEFAULT_SIZE, 391, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jbtnAceptar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jbtnCancelar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(15, 15, 15))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jbtnAceptar)
                        .addGap(18, 18, 18)
                        .addComponent(jbtnCancelar))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jTabCU, javax.swing.GroupLayout.PREFERRED_SIZE, 264, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(27, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Método para editar las propiedades de un caso de uso
     * @param Caso caso de uso para editar
     */
    public void editarPropiedades (CasodeUso Caso){
        editar = true;
        auxCU = Caso;
        auxPasos = (List<PasoCU>) Caso.getPasoCU();
        jtxtId.setText(Caso.getIdent());
        jtxtNombreCU.setText(Caso.getNombre());
        jchbesAbstracto.setSelected(Caso.getEsAbstracto());
        jtxaEventoActivacion.setText(Caso.getEventoActivacion());
        jtxtFrecuencia.setText(String.valueOf(Caso.getFrecuencia()));
        jtxtUnidadFrecuencia.setText(Caso.getUnidadFrecuencia());
        jtxaPrecondicion.setText(Caso.getPrecondicion());
        jtxaPostcondicion.setText(Caso.getPostcondicion());
        jcbEstabilidad.setSelectedItem(Caso.getEstabilidad());
        jcbEstado.setSelectedItem(Caso.getEstadodeDesarrollo());
        jcbUrgencia.setSelectedItem(Caso.getUrgencia());
        jcbImportancia.setSelectedItem(Caso.getImportancia());
    }

    /**
     * jbtnAceptarActionPerformed Activa el boton aceptar
     * @param evt
     */
    private void jbtnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAceptarActionPerformed
        String ident;
        int i, l=0;
        ident=jtxtId.getText();
        if (!editar) {
            if (auxDocPpal.getCasodeUso().size() != 0) {
                l = auxDocPpal.getCasodeUso().size();
                l--;
                i = auxDocPpal.getCasodeUso().get(l).getId_n();
            } else {
                i = 0;
            }
            newCU = auxDocPpal.nuevoCU(i+1, jtxtNombreCU.getText(), jchbesAbstracto.isSelected(), jtxaEventoActivacion.getText(), Integer.parseInt(jtxtFrecuencia.getText()), jtxtUnidadFrecuencia.getText(), jtxaPrecondicion.getText(), jtxaPostcondicion.getText(), jcbImportancia.getSelectedItem().toString(), jcbUrgencia.getSelectedItem().toString(), jcbEstado.getSelectedItem().toString(), jcbEstabilidad.getSelectedItem().toString());
            MutableTreeNode node = new DefaultMutableTreeNode(newCU.getIdent());
            DefaultTreeModel model = (DefaultTreeModel) jfaux.getJtreDocumento().getModel();
            model.insertNodeInto(node, auxinsertNode, auxinsertIndex);
            jfaux.LeeArbol();
            mostrarmensaje("Insertado el CU " + newCU.getNombre());
            jfaux.setEnabled(true);
            this.dispose();
        } else {
            boolean encontrado = false;
            i = 0;
            while (i < auxDocPpal.getCasodeUso().size() && encontrado == false) {
                if (auxDocPpal.getCasodeUso().get(i).getIdent().equals(ident)) {
                    encontrado = true;
                    auxDocPpal.getCasodeUso().get(i).setNombre(jtxtNombreCU.getText());
                    auxDocPpal.getCasodeUso().get(i).setEsAbstracto(jchbesAbstracto.isSelected());
                    auxDocPpal.getCasodeUso().get(i).setEventoActivacion(jtxaEventoActivacion.getText());
                    auxDocPpal.getCasodeUso().get(i).setFrecuencia(Integer.parseInt(jtxtFrecuencia.getText()));
                    auxDocPpal.getCasodeUso().get(i).setUnidadFrecuencia(jtxtUnidadFrecuencia.getText());
                    auxDocPpal.getCasodeUso().get(i).setPrecondicion(jtxaPrecondicion.getText());
                    auxDocPpal.getCasodeUso().get(i).setPostcondicion(jtxaPostcondicion.getText());
                    auxDocPpal.getCasodeUso().get(i).setImportancia(jcbImportancia.getSelectedItem().toString());
                    auxDocPpal.getCasodeUso().get(i).setUrgencia(jcbUrgencia.getSelectedItem().toString());
                    auxDocPpal.getCasodeUso().get(i).setEstadodeDesarrollo(jcbEstado.getSelectedItem().toString());
                    auxDocPpal.getCasodeUso().get(i).setEstabilidad(jcbEstabilidad.getSelectedItem().toString());
                    auxDocPpal.getCasodeUso().get(i).actualizarBD(auxDocPpal.getCasodeUso().get(i));
                }
                i++;
            }
            jfaux.LeeArbol();
            mostrarmensaje("Insertado el CU " + auxDocPpal.getCasodeUso().get(i-1).getNombre());
            jfaux.setEnabled(true);
            this.dispose();
        }
    }//GEN-LAST:event_jbtnAceptarActionPerformed

    /**
     * formWindowClosed es el metodo que se activa cuando pulsamos la x de cerrar
     * @param evt
     */
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_formWindowClosed

    /**
     * jbtnCancelarActionPerformed Activa el boton cancelar
     * @param evt
     */
    private void jbtnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnCancelarActionPerformed
        jfaux.LeeArbol();
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_jbtnCancelarActionPerformed

    /**
    * @param args the command line arguments
    */
    /*public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
    public void run() {
    new jfrmCasodeUso().setVisible(true);
    }
    });
    }*/

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTabbedPane jTabCU;
    private javax.swing.JButton jbtnAceptar;
    private javax.swing.JButton jbtnCancelar;
    private javax.swing.JComboBox jcbEstabilidad;
    private javax.swing.JComboBox jcbEstado;
    private javax.swing.JComboBox jcbImportancia;
    private javax.swing.JComboBox jcbUrgencia;
    private javax.swing.JCheckBox jchbesAbstracto;
    private javax.swing.JPanel jpanGeneral;
    private javax.swing.JPanel jpanPrePost;
    private javax.swing.JPanel jpanPrioridad;
    private javax.swing.JTextArea jtxaEventoActivacion;
    private javax.swing.JTextArea jtxaPostcondicion;
    private javax.swing.JTextArea jtxaPrecondicion;
    private javax.swing.JTextField jtxtFrecuencia;
    private javax.swing.JTextField jtxtId;
    private javax.swing.JTextField jtxtNombreCU;
    private javax.swing.JTextField jtxtUnidadFrecuencia;
    // End of variables declaration//GEN-END:variables


    /**
     * Muestra un mensaje en un JOptionPane
     * @param mensaje a mostrar en el JOptionPane
     */
    private void mostrarmensaje(String mensaje) {
         JOptionPane.showMessageDialog(this, mensaje, "Advertencia",
                                JOptionPane.WARNING_MESSAGE);
    }
    /**
     * update Método que es llamado cuando el objeto observado cambia
     * @param o objeto observable
     * @param arg argumento pasado al método notifyObservers
     */
    public void update(Observable o, Object arg) {
        jtxtNombreCU.setText(String.valueOf(newCU.getNombre()));
        jchbesAbstracto.setSelected(newCU.getEsAbstracto());
        jtxaEventoActivacion.setText(String.valueOf(newCU.getEventoActivacion()));
        jtxtFrecuencia.setText(String.valueOf(newCU.getFrecuencia()));
        jtxtUnidadFrecuencia.setText(String.valueOf(newCU.getUnidadFrecuencia()));
        jtxaPrecondicion.setText(String.valueOf(newCU.getPrecondicion()));
        jtxaPostcondicion.setText(String.valueOf(newCU.getPostcondicion()));
        jcbImportancia.setSelectedItem(String.valueOf(newCU.getImportancia()));
        jcbUrgencia.setSelectedItem(String.valueOf(newCU.getUrgencia()));
        jcbEstado.setSelectedItem(String.valueOf(newCU.getEstadodeDesarrollo()));
        jcbEstabilidad.setSelectedItem(String.valueOf(newCU.getEstabilidad()));
    }
}
