/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * jfrmDocumentoReq.java
 *
 * Created on 01-feb-2012, 18:17:46
 */

package vista;

import java.util.Observable;
import javax.swing.JOptionPane;
import modelo.DocumentoReq;
import java.util.Observer;
import javax.swing.ImageIcon;
import modelo.GestorDocus;

/**
 * jfrmActor es el formulario con el cual podremos insertar el documento de requisitos
 */
public class jfrmDocumentoReq extends javax.swing.JFrame implements Observer {
    boolean editar=false;
    jfrmPrincipal jfaux;
    DocumentoReq auxDoc;
    GestorDocus auxGD;

    /**
     * Constructor de JFrame DocumentoReq
     */
    public jfrmDocumentoReq(){
        initComponents();
        int i = 1;
        auxDoc.setId_n(i);
        auxDoc.setId("DOCR");
        auxDoc.setNombre("SinNombre"+auxDoc.getId_n());
        auxDoc.setFecha(jSpFecha.toString());
        auxDoc.setCreador("?");
        auxDoc.setPreparado("?");
        auxDoc.setComentario("?");
        String ident;
        ident ="DOCR"+String.valueOf(i);

        jtxtId.setText(ident);
    }

    /**
     *
     * @param jf el formulario principal
     * @param GD
     * @param doc
     */
    public jfrmDocumentoReq(jfrmPrincipal jf, GestorDocus GD, DocumentoReq doc) {
        jfaux=jf;
        auxDoc = doc;
        auxGD = GD;
        this.setIconImage(new ImageIcon("src/imagenes/documento.jpg").getImage());
        initComponents();
        
    }

    /**
     * editarPropiedades Método que edita las propiedades de un documento de requisitos
     * @param doc documento de requisitos para editar
     */
    void editarPropiedades(DocumentoReq doc) {
        editar = true;
        int i = 0;
        if (auxGD.getDocReq().size() == 0) {
            i++;
        } else {
            i=auxGD.getDocReq().size();
        }
        String ident;
        ident ="DOCR"+String.valueOf(i);
        jtxtId.setText(ident);
        jtxtNombre.setText(doc.getNombre());
        jtxtCreador.setText(doc.getCreador());
        jSpFecha.setToolTipText(doc.getFecha());
        jtxaComentario.setText(doc.getComentario());
        jtxtPreparado.setText(doc.getPreparado());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabReunion = new javax.swing.JTabbedPane();
        jpanGeneral = new javax.swing.JPanel();
        jlbLugar = new javax.swing.JLabel();
        jlbFechaHora = new javax.swing.JLabel();
        jtxtCreador = new javax.swing.JTextField();
        jlbAsistentes = new javax.swing.JLabel();
        jlbNombre = new javax.swing.JLabel();
        jtxtNombre = new javax.swing.JTextField();
        jSpFecha = new javax.swing.JSpinner();
        jtxtId = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        jtxtPreparado = new javax.swing.JTextField();
        jpanResultados = new javax.swing.JPanel();
        jlbResultados = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtxaComentario = new javax.swing.JTextArea();
        jbtnAceptar = new javax.swing.JButton();
        jbtnCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Documento");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jlbLugar.setText("Creador:");

        jlbFechaHora.setText("Fecha y hora:");

        jlbAsistentes.setText("Preparado para:");

        jlbNombre.setText("Nombre");

        jSpFecha.setModel(new javax.swing.SpinnerDateModel());

        jtxtId.setEditable(false);

        jLabel14.setText("Identificador:");

        javax.swing.GroupLayout jpanGeneralLayout = new javax.swing.GroupLayout(jpanGeneral);
        jpanGeneral.setLayout(jpanGeneralLayout);
        jpanGeneralLayout.setHorizontalGroup(
            jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanGeneralLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jLabel14, javax.swing.GroupLayout.DEFAULT_SIZE, 65, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jtxtId, javax.swing.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE)
                        .addGap(256, 256, 256))
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jlbFechaHora)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jSpFecha, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(252, Short.MAX_VALUE))
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jpanGeneralLayout.createSequentialGroup()
                                .addComponent(jlbAsistentes)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jtxtPreparado))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jpanGeneralLayout.createSequentialGroup()
                                .addComponent(jlbNombre)
                                .addGap(10, 10, 10)
                                .addComponent(jtxtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, 214, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jpanGeneralLayout.createSequentialGroup()
                                .addComponent(jlbLugar)
                                .addGap(20, 20, 20)
                                .addComponent(jtxtCreador, javax.swing.GroupLayout.PREFERRED_SIZE, 278, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addContainerGap(82, Short.MAX_VALUE))))
        );
        jpanGeneralLayout.setVerticalGroup(
            jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanGeneralLayout.createSequentialGroup()
                .addGap(12, 12, 12)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtxtId)
                    .addComponent(jLabel14, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jtxtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jlbNombre))
                .addGap(18, 18, 18)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jtxtCreador, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jlbLugar))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlbFechaHora)
                    .addComponent(jSpFecha, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlbAsistentes)
                    .addComponent(jtxtPreparado, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(112, 112, 112))
        );

        jTabReunion.addTab("General", jpanGeneral);

        jlbResultados.setText("Comentarios");

        jtxaComentario.setColumns(20);
        jtxaComentario.setRows(5);
        jtxaComentario.setText("PD");
        jScrollPane1.setViewportView(jtxaComentario);

        javax.swing.GroupLayout jpanResultadosLayout = new javax.swing.GroupLayout(jpanResultados);
        jpanResultados.setLayout(jpanResultadosLayout);
        jpanResultadosLayout.setHorizontalGroup(
            jpanResultadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanResultadosLayout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(jpanResultadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 395, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jlbResultados))
                .addContainerGap(18, Short.MAX_VALUE))
        );
        jpanResultadosLayout.setVerticalGroup(
            jpanResultadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanResultadosLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jlbResultados)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 216, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(17, Short.MAX_VALUE))
        );

        jTabReunion.addTab("Comentarios", jpanResultados);

        jbtnAceptar.setText("Aceptar");
        jbtnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAceptarActionPerformed(evt);
            }
        });

        jbtnCancelar.setText("Cancelar");
        jbtnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(454, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jbtnAceptar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jbtnCancelar)))
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(jTabReunion, javax.swing.GroupLayout.PREFERRED_SIZE, 438, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(81, Short.MAX_VALUE)))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jbtnAceptar)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jbtnCancelar)
                .addContainerGap(239, Short.MAX_VALUE))
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                    .addGap(4, 4, 4)
                    .addComponent(jTabReunion, javax.swing.GroupLayout.PREFERRED_SIZE, 292, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * jbtnAceptarActionPerformed Activa el boton aceptar
     * @param evt
     */
    private void jbtnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAceptarActionPerformed
        int i = 1;
        //auxDoc = auxGD.editarDocu(i, jtxtNombre.getText(), jSpFecha.getToolTipText(), jtxtCreador.getText(), jtxtPreparado.getText(), jtxaComentario.getText());
        auxDoc.setId_n(i);
        auxDoc.setId("DOCR");
        auxDoc.setNombre(jtxtNombre.getText());
        auxDoc.setFecha(jSpFecha.getValue().toString());
        auxDoc.setCreador(jtxtCreador.getText());
        auxDoc.setPreparado(jtxtPreparado.getText());
        auxDoc.setComentario(jtxaComentario.getText());
        jfaux.LeeArbol();
        mostrarmensaje("Modificadas las propiedades del Documento");
        jfaux.setEnabled(true);
        this.dispose();
}//GEN-LAST:event_jbtnAceptarActionPerformed

    /**
     * jbtnCancelarActionPerformed Activa el boton cancelar
     * @param evt
     */
    private void jbtnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnCancelarActionPerformed
        jfaux.LeeArbol();
        jfaux.setEnabled(true);
        this.dispose();
}//GEN-LAST:event_jbtnCancelarActionPerformed

    /**
     * formWindowClosed es el metodo que se activa cuando pulsamos la x de cerrar
     * @param evt
     */
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_formWindowClosed

    /**
    * @param args the command line arguments
    */
//    public static void main(String args[]) {
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                new jfrmDocumentoReq().setVisible(true);
//            }
//        });
//    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel14;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSpinner jSpFecha;
    private javax.swing.JTabbedPane jTabReunion;
    private javax.swing.JButton jbtnAceptar;
    private javax.swing.JButton jbtnCancelar;
    private javax.swing.JLabel jlbAsistentes;
    private javax.swing.JLabel jlbFechaHora;
    private javax.swing.JLabel jlbLugar;
    private javax.swing.JLabel jlbNombre;
    private javax.swing.JLabel jlbResultados;
    private javax.swing.JPanel jpanGeneral;
    private javax.swing.JPanel jpanResultados;
    private javax.swing.JTextArea jtxaComentario;
    private javax.swing.JTextField jtxtCreador;
    private javax.swing.JTextField jtxtId;
    private javax.swing.JTextField jtxtNombre;
    private javax.swing.JTextField jtxtPreparado;
    // End of variables declaration//GEN-END:variables

    /**
     * Muestra un mensaje en un JOptionPane
     * @param mensaje a mostrar en el JOptionPane
     */
    private void mostrarmensaje(String mensaje) {
         JOptionPane.showMessageDialog(this, mensaje, "Advertencia",
                                JOptionPane.WARNING_MESSAGE);
    }

    public void update(Observable o, Object arg) {
        
    }
}
